#/usr/bin/env python
"""
This simple example is used for the line-by-line tutorial
that comes with pygame. It is based on a 'popular' web banner.
Note there are comments here, but for the full explanation, 
follow along in the tutorial.
"""


#Import Modules
import os, pygame, math, random
from pygame.locals import *

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'

GAMESIZEX = 768
GAMESIZEY = 1024

images = []
temp_surface = pygame.image.load(os.path.join("data/image","intro.bmp"))
images.append(temp_surface)
temp_surface = pygame.image.load(os.path.join("data/image","tutorial.bmp"))
images.append(temp_surface)
temp_surface = pygame.image.load(os.path.join("data/image","credits.bmp"))
images.append(temp_surface)

tankBottomImages = []
tankTopImages = []
i = 0
while i < 32:
	if i < 10:
		temp_surface = pygame.image.load(os.path.join("data/units","tank groundpart000" + str(i) + ".bmp"))
	else:
		temp_surface = pygame.image.load(os.path.join("data/units","tank groundpart00" + str(i) + ".bmp"))
	temp_surface.set_colorkey((97,68,43))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, .5)
	tankBottomImages += [temp_surface]
	if i < 10:
		temp_surface = pygame.image.load(os.path.join("data/units","upper part 000" + str(i) + ".bmp"))
	else:
		temp_surface = pygame.image.load(os.path.join("data/units","upper part 00" + str(i) + ".bmp"))
	temp_surface.set_colorkey((97,68,43))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, .5)
	tankTopImages += [temp_surface]
	i+=1
	
workerEmpty = []
workerWood = []
workerCoal = []
workerGold = []
workerSteam = []

i = 0
t = 0
while t < 5:
	if t == 0:
		first = "data/worker/empty"
	elif t == 1:
		first = "data/worker/wood"
	elif t == 2:
		first = "data/worker/coal"
	elif t == 3:
		first = "data/worker/gold"
	elif t == 4:
		first = "data/worker/steam"
		
	while i < 9:
		if i == 0:
			
			start = "stopped000"
			end = ".bmp"
			increment = 1
			startAt = 0
			max = 8
		if i >= 1:
			
			if i == 1:
				start = "walking n000"
			elif i == 2:
				start = "walking ne000"
			elif i == 3:
				start = "walking e000"
			elif i == 4:
				start = "walking se000"		
			elif i == 5:
				start = "walking s000"
			elif i == 6:
				start = "walking sw000"
			elif i == 7:
				start = "walking w000"
			elif i == 8:
				start = "walking nw000"
			end = ".bmp"
			increment = 2
			startAt = 0
			max = 8
		w = []
		while startAt < max:
			temp_surface = pygame.image.load(os.path.join(first,start +str(startAt) + end))
			temp_surface.set_colorkey((97,68,43))
			temp_surface = pygame.transform.rotozoom(temp_surface, 0, .5)
			w += [temp_surface]
			startAt+=increment
		if t == 0:
			workerEmpty.append(w)
		elif t == 1:
			workerWood.append(w)
		elif t == 2:
			workerCoal.append(w)
		elif t == 3:
			workerGold.append(w)
		elif t == 4:
			workerSteam.append(w)
		i+=1
	i = 0
	t+=1
i = 0
planePics = []
while i < 8:
	temp_surface = pygame.image.load(os.path.join("data/units","plane"+str(i)+".bmp"))
	temp_surface.set_colorkey((0,255,36))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
	planePics.append(temp_surface)
	i+=1
	
resourcePics = []
temp_surface = pygame.image.load(os.path.join("data/resources","tree.bmp"))
temp_surface.set_colorkey((255,102,0))
temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
resourcePics.append(temp_surface)

temp_surface = pygame.image.load(os.path.join("data/resources","coal.bmp"))
temp_surface.set_colorkey((255,102,0))
temp_surface = pygame.transform.rotozoom(temp_surface, 0, .5)
resourcePics.append(temp_surface)

temp_surface = pygame.image.load(os.path.join("data/resources","gold.bmp"))
temp_surface.set_colorkey((255,102,0))
temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
resourcePics.append(temp_surface)

guiPics = [] #0 gold 1 steam 2 food
temp_surface = pygame.image.load(os.path.join("data/gui","steam.bmp"))
temp_surface.set_colorkey((255,135,194))
temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
guiPics.append(temp_surface)
temp_surface = pygame.image.load(os.path.join("data/gui","gold.bmp"))
temp_surface.set_colorkey((255,135,194))
temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
guiPics.append(temp_surface)
temp_surface = pygame.image.load(os.path.join("data/gui","food.bmp"))
temp_surface.set_colorkey((255,135,194))
temp_surface = pygame.transform.rotozoom(temp_surface, 0, .7)
guiPics.append(temp_surface)

artilleryPics = []
i = 0
while i < 8:
	temp_surface = pygame.image.load(os.path.join("data/units","artillery"+str(i)+".bmp"))
	temp_surface.set_colorkey((246,255,0))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
	artilleryPics.append(temp_surface)
	i +=1

soldierPic = []
i = 0
while i < 8:
	temp_surface = pygame.image.load(os.path.join("data/units","redsoldier"+str(i)+".bmp"))
	temp_surface.set_colorkey((255,255,255))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
	soldierPic.append(temp_surface)
	i +=1
i = 0
while i < 8:
	temp_surface = pygame.image.load(os.path.join("data/units","bluesoldier"+str(i)+".bmp"))
	temp_surface.set_colorkey((255,255,255))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
	soldierPic.append(temp_surface)
	i +=1
	
turretPicsRed = []
i = 0
while i < 8:
	temp_surface = pygame.image.load(os.path.join("data/buildings","turret"+str(i)+"red.bmp"))
	temp_surface.set_colorkey((255,0,240))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
	turretPicsRed.append(temp_surface)
	i +=1
turretPicsBlue = []
i = 0
while i < 8:
	temp_surface = pygame.image.load(os.path.join("data/buildings","turret"+str(i)+"blue.bmp"))
	temp_surface.set_colorkey((255,0,240))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
	turretPicsBlue.append(temp_surface)
	i +=1
	
turretPics = []
i = 0
while i < 8:
	temp_surface = pygame.image.load(os.path.join("data/buildings","turret"+str(i)+".bmp"))
	temp_surface.set_colorkey((255,0,240))
	temp_surface = pygame.transform.rotozoom(temp_surface, 0, 1)
	turretPics.append(temp_surface)
	i +=1
	
turretbullet = pygame.image.load(os.path.join("data/buildings","turretbullet.bmp"))
turretbullet.set_colorkey((255,255,255))
turretbullet = pygame.transform.rotozoom(turretbullet, 0, 1)

airstripPic = pygame.image.load(os.path.join("data/buildings","airstrip.bmp"))
airstripPic = pygame.transform.rotozoom(airstripPic, 0, 1)

commandcenterPic = pygame.image.load(os.path.join("data/buildings","commandcenter.bmp"))
commandcenterPic.set_colorkey((255,255,255))
commandcenterPic = pygame.transform.rotozoom(commandcenterPic, 0, 1)

farmPic = pygame.image.load(os.path.join("data/buildings","farm.bmp"))
farmPic.set_colorkey((191,123,199))
farmPic = pygame.transform.rotozoom(farmPic, 0, 1)

factoryPic = pygame.image.load(os.path.join("data/buildings","factory.bmp"))
factoryPic.set_colorkey((255,0,240))
factoryPic = pygame.transform.rotozoom(factoryPic, 0, .8)

mapPics = [] #0 dirt, 1 grass, 2 dark grass, 3 dark dark grass, 4 weeds
temp = pygame.image.load(os.path.join("data/map","dirt.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
mapPics.append(temp)

temp = pygame.image.load(os.path.join("data/map","grass.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
mapPics.append(temp)

temp = pygame.image.load(os.path.join("data/map","dgrass.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
mapPics.append(temp)

temp = pygame.image.load(os.path.join("data/map","ddgrass.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
mapPics.append(temp)

temp = pygame.image.load(os.path.join("data/map","weeds.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
mapPics.append(temp)

temp = pygame.image.load(os.path.join("data/map","mud.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
mapPics.append(temp)

mapPicsT = []
temp = pygame.image.load(os.path.join("data/map","dirth.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
tempt = pygame.image.load(os.path.join("data/map","dirtv.bmp"))
tempt = pygame.transform.rotozoom(tempt, 0, 1)
mapPicsT.append((temp,tempt))
temp = pygame.image.load(os.path.join("data/map","grassh.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
tempt = pygame.image.load(os.path.join("data/map","grassv.bmp"))
tempt = pygame.transform.rotozoom(tempt, 0, 1)
mapPicsT.append((temp,tempt))
temp = pygame.image.load(os.path.join("data/map","dgrassh.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
tempt = pygame.image.load(os.path.join("data/map","dgrassv.bmp"))
tempt = pygame.transform.rotozoom(tempt, 0, 1)
mapPicsT.append((temp,tempt))
temp = pygame.image.load(os.path.join("data/map","ddgrassh.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
tempt = pygame.image.load(os.path.join("data/map","ddgrassv.bmp"))
tempt = pygame.transform.rotozoom(tempt, 0, 1)
mapPicsT.append((temp,tempt))
temp = pygame.image.load(os.path.join("data/map","weedsh.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
tempt = pygame.image.load(os.path.join("data/map","weedsv.bmp"))
tempt = pygame.transform.rotozoom(tempt, 0, 1)
mapPicsT.append((temp,tempt))
temp = pygame.image.load(os.path.join("data/map","mudh.bmp"))
temp = pygame.transform.rotozoom(temp, 0, 1)
tempt = pygame.image.load(os.path.join("data/map","mudv.bmp"))
tempt = pygame.transform.rotozoom(tempt, 0, 1)
mapPicsT.append((temp,tempt))

#functions to create our resources
def load_image(name, colorkey=None):
	fullname = os.path.join('data', name)
	try:
		image = pygame.image.load(fullname)
	except pygame.error, message:
		print 'Cannot load image:', fullname
		raise SystemExit, message
	image = image.convert()
	if colorkey is not None:
		if colorkey is -1:
			colorkey = image.get_at((0,0))
		image.set_colorkey(colorkey, RLEACCEL)
	return image, image.get_rect()

def load_sound(name):
	class NoneSound:
		def play(self): pass
	if not pygame.mixer or not pygame.mixer.get_init():
		return NoneSound()
	fullname = os.path.join('data', name)
	try:
		sound = pygame.mixer.Sound(fullname)
	except pygame.error, message:
		print 'Cannot load sound:', fullname
		raise SystemExit, message
	return sound


def calcQuad(x,y):
		quadrant = []
		#set the quadrant
		if y < (GAMESIZEY/3):
			if x < (GAMESIZEX/3):
				quadrant = quadrant + [1]
			if x < (2*GAMESIZEX)/3 and x > (GAMESIZEX/3):
				quadrant = quadrant + [2]
			if x > (2*GAMESIZEX)/3:
				quadrant = quadrant + [3]
				
		if y > GAMESIZEY/3 and y < (2*GAMESIZEY)/3:
			if x < (GAMESIZEX/3):
				quadrant = quadrant + [4]
			if x < (2*GAMESIZEX)/3 and x > (GAMESIZEX/3):
				quadrant = quadrant + [5]
			if x > (2*GAMESIZEX)/3:
				quadrant = quadrant + [6]
				
		if y > (2*GAMESIZEY)/3:
			if x < (GAMESIZEX/3):
				quadrant = quadrant + [7]
			if x < (2*GAMESIZEX)/3 and x > (GAMESIZEX/3):
				quadrant = quadrant + [8]
			if x > (2*GAMESIZEX)/3:
				quadrant = quadrant + [9]
		if quadrant == []:
			quadrant = [0]
		return quadrant
def getPlayer(player):
	if player == 0:
		return humanPlayer
	else:
		return compuPlayer

class Projectile:	
	
	def __init__(self,posX,posY,goalX,goalY,speed,size,damage,area,owner):
		self.x = posX
		self.y = posY
		self.goalx = goalX
		self.goaly = goalY
		self.speed = speed
		self.size = size
		self.damage = damage
		self.area = area
		self.owner = owner
	def blow(self, units):
		#finds out which objects to hurt
		self.calcQuadrant()
		for u in units:
			for s in self.quadrant:
				if s in u.quadrant:
					#check for boom
					self.urect = pygame.Rect((u.x-u.sizex,u.y-u.sizey),(u.sizex*2,u.sizey*2))
					self.temp = self.area*math.sqrt(2)/2
					points = [(self.x,self.y),(self.x+self.area,self.y),(self.x-self.area,self.y),(self.x,self.y+self.area),(self.x,self.y-self.area),(self.x+self.temp,self.y+self.temp),(self.x-self.temp,self.y+self.temp),(self.x+self.temp,self.y-self.temp),(self.x-self.temp,self.y-self.temp)]
					self.takedamage = False
					for p in points:
						if self.urect.collidepoint(p) == True:
							self.takedamage = True
					if self.takedamage == True:
						u.takeDamage(self.damage,self.owner)
						self.takeDamage = False
		for b in buildings:
			for s in self.quadrant:
				if s in b.quadrant:
					#check for boom
					
					self.urect = pygame.Rect((b.x-b.sizex,b.y-b.sizey),(b.sizex*2,b.sizey*2))
					self.temp = self.area*math.sqrt(2)/2
					points = [(self.x+self.area,self.y),(self.x-self.area,self.y),(self.x,self.y+self.area),(self.x,self.y-self.area),(self.x+self.temp,self.y+self.temp),(self.x-self.temp,self.y+self.temp),(self.x+self.temp,self.y-self.temp),(self.x-self.temp,self.y-self.temp)]
					self.takedamage = False
					for p in points:
						if self.urect.collidepoint(p) == True:
							
							self.takedamage = True
					if self.takedamage == True:
						b.takeDamage(self.damage,self.owner)
						self.takeDamage = False
							
	def update(self):

		if self.x == self.goalx and self.y == self.goaly:			
			return 1
	

		self.distanceToGoal = math.sqrt(math.fabs((self.goalx-self.x))*math.fabs((self.goalx-self.x)) + math.fabs((self.goaly-self.y))*math.fabs((self.goaly-self.y)))
		if self.distanceToGoal < self.speed:
			self.x = self.goalx
			self.y = self.goaly
		else:
			self.x = self.x+(self.speed*(self.goalx-self.x))/self.distanceToGoal
			self.y = self.y+(self.speed*(self.goaly-self.y))/self.distanceToGoal
			
		return -1

	def draw(self):
		self.surface = pygame.display.get_surface()		
		pygame.draw.circle(self.surface, (0,0,0), (int(self.x),int(self.y)), self.size+1, 0)

	def calcQuadrant(self):
		self.quadrant = []
		#set the quadrant
		if self.y-self.size < (GAMESIZEY/3):
			if self.x-self.size < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [1]
			if self.x-self.size < (2*GAMESIZEX)/3 and self.x+self.size > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [2]
			if self.x+self.size > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [3]
				
		if self.y+self.size > GAMESIZEY/3 and self.y-self.size < (2*GAMESIZEY)/3:
			if self.x-self.size < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [4]
			if self.x-self.size < (2*GAMESIZEX)/3 and self.x+self.size > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [5]
			if self.x+self.size > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [6]
				
		if self.y+self.size > (2*GAMESIZEY)/3:
			if self.x-self.size < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [7]
			if self.x-self.size < (2*GAMESIZEX)/3 and self.x+self.size > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [8]
			if self.x+self.size > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [9]

class ArtilleryProjectile(Projectile):
	def __init__(self,posX,posY,goalX,goalY,damage,owner):
		Projectile.__init__(self,posX,posY,goalX,goalY,10,5,damage,5,owner)
		self.fulldistancetogoal = math.sqrt(math.fabs((self.goalx-self.x))*math.fabs((self.goalx-self.x)) + math.fabs((self.goaly-self.y))*math.fabs((self.goaly-self.y)))
		self.calcy = self.y
	def update(self):
		if self.x == self.goalx and self.calcy == self.goaly:			
			return 1
	

		self.distanceToGoal = math.sqrt(math.fabs((self.goalx-self.x))*math.fabs((self.goalx-self.x)) + math.fabs((self.goaly-self.calcy))*math.fabs((self.goaly-self.calcy)))
		if self.distanceToGoal < self.speed:
			self.x = self.goalx
			self.calcy = self.goaly
		else:
			self.x = self.x+(self.speed*(self.goalx-self.x))/self.distanceToGoal
			self.calcy = self.calcy+(self.speed*(self.goaly-self.calcy))/self.distanceToGoal
		
		
		self.y = self.calcy + self.distanceToGoal*(self.distanceToGoal - self.fulldistancetogoal)/200
		return -1
	def blow(self, units):
		#finds out which objects to hurt
		self.calcQuadrant()
		for u in units:
			if u.soldier == True:
				for s in self.quadrant:
					if s in u.quadrant:
						#check for boom
						self.urect = pygame.Rect((u.x-u.sizex,u.y-u.sizey),(u.sizex*2,u.sizey*2))
						self.temp = self.area*math.sqrt(2)/2
						points = [(self.x,self.y),(self.x+self.area,self.y),(self.x-self.area,self.y),(self.x,self.y+self.area),(self.x,self.y-self.area),(self.x+self.temp,self.y+self.temp),(self.x-self.temp,self.y+self.temp),(self.x+self.temp,self.y-self.temp),(self.x-self.temp,self.y-self.temp)]
						self.takedamage = False
						for p in points:
							if self.urect.collidepoint(p) == True:
								self.takedamage = True
						if self.takedamage == True:
							u.takeDamage(self.damage,self.owner)
							self.takeDamage = False
		
class TurretProjectile(Projectile):
	def __init__(self,posX,posY,goalX,goalY,damage,owner):
		Projectile.__init__(self,posX,posY,goalX,goalY,10,5,damage,5,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()		
		self.surface.blit(turretbullet,(int(self.x),int(self.y)))
class move:
	def __init__(self,oldx,oldy,oldQuadrant,unit):
		self.oldx = oldx
		self.oldy = oldy
		self.quadrant = oldQuadrant
		self.unit = unit
		self.oldrect = pygame.Rect((self.oldx-self.unit.sizex,self.oldy-self.unit.sizey),(self.unit.sizex*2,self.unit.sizey*2))
	
	def setNew(self,newx,newy,newQuadrant):
		self.newx = newx
		self.newy = newy
		for q in newQuadrant:
			if q in self.quadrant:
				pass
			else:
				self.quadrant = self.quadrant + [q]
		self.newrect = pygame.Rect((self.newx-self.unit.sizex,self.newy-self.unit.sizey),(self.unit.sizex*2,self.unit.sizey*2))
		
	def hasMoved(self):
		if self.newx == self.oldx and self.newy == self.oldy:
			return False
		else:
			return True
	def setOld(self,oldx,oldy,oldQuadrant):
		self.oldx = oldx
		self.oldy = oldy
		for q in oldQuadrant:
			if q in self.quadrant:
				pass
			else:
				self.quadrant = self.quadrant + [q]
	
	def collide(self,moveObject):
		
		for n in self.quadrant:
			for m in moveObject.quadrant:
				if n == m:
					return self.checkCollide(moveObject)
					
		return False
	def collideBuilding(self, b):
		for n in self.quadrant:
			for m in b.quadrant:
				if n == m:
					if self.newrect.colliderect(b.rect) == True:
						return True
					else:
						return False
	
	def checkCollide(self,moveObject):
		#comparing new positions
		if self.newrect.colliderect(moveObject.oldrect) == True:
			
			return True
		else:
			return False


class Unit:

	def __init__(self,posX,posY,moverate,turnrate,direction,sizeX,sizeY,curHP,maxHP,team,range,fireRate,food,usesSteam,maxSteam,currentSteam,steamUse,damage):
		self.x = posX
		self.y = posY
		self.prevx = self.x
		self.prevy = self.y
		self.moverate = moverate
		self.turnrate = turnrate
		self.direction = direction
		self.goalx = posX
		self.goaly = posY
		self.sizex = sizeX
		self.sizey = sizeY
		self.surface = pygame.display.get_surface()
		self.selected = False
		self.quadrant = []
		self.showHP = False
		self.curHP = curHP
		self.maxHP = maxHP
		self.attacking = 0
		self.team = team
		self.range = range
		self.firerate = fireRate
		self.firecounter = 0
		self.actionInterface = ActionInterface([])
		self.agro = True
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		self.food = food
		self.usesSteam = usesSteam
		self.maxSteam = maxSteam
		self.currentSteam = currentSteam
		self.steamUse= steamUse
		self.soldier = False
		self.calcQuadrant()
		self.worker = False
		self.goalxattack = -1
		self.goalyattack = -1
		self.damage = damage
				
	def undo(self):
		self.x = self.prevx
		self.y = self.prevy
		
	def changePos(self,changex,changey):
		
		self.x += changex
		self.y += changey
		
	def takeDamage(self,d,projOwner):
		self.curHP -= d
		
		if self.attacking == 0 and self.goalx == self.x and self.goaly == self.y:
			#i'm doing nothing and I just got attacked, eat it 
			self.attacking = projOwner
			self.goalx = projOwner.x
			self.goaly = projOwner.y

	def fire(self):
		if self.firecounter != 0:
			self.firecounter -= 1
		else:
			p = Projectile(self.x,self.y,self.goalx,self.goaly,10,3,self.damage,10,self)		
			projs.append(p)
			self.firecounter = self.firerate
		
	def setGoal(self,goalX,goalY):
		self.goalQuad = calcQuad(goalX,goalY)
		for u in units:
			if u.team != self.team:
				if self.goalQuad[0] in u.quadrant:
					
					self.rectTwo = pygame.Rect((u.x-u.sizex,u.y-u.sizey),(u.sizex*2,u.sizey*2))
					if self.rectTwo.collidepoint((goalX,goalY)):
						self.setAttackGoal(u)
						self.setMoveGoal(goalX,goalY)
						return
		for b in buildings:
			if b.team != self.team:
				if self.goalQuad[0] in b.quadrant:
					
					self.rectTwo = pygame.Rect((b.x-b.sizex,b.y-b.sizey),(b.sizex*2,b.sizey*2))
					if self.rectTwo.collidepoint((goalX,goalY)):
						self.setAttackGoal(b)
						self.setMoveGoal(goalX,goalY)
						return
		self.attacking = 0
		self.setMoveGoal(goalX,goalY)
					
	def attackMove(self,x,y):
		self.goalxattack = x
		self.goalyattack = y
		
	def setMoveGoal(self,goalX,goalY):
		self.goalx = goalX
		self.goaly = goalY
		
	def setAttackGoal(self,u):
		
		self.attacking = u
	
	def HPshow(self,toShow):
		self.showHP = toShow
	
	def drawHP(self):

		self.rect = pygame.Rect((self.x-self.sizex-5,self.y+self.sizey+4),(self.sizex*2+10,5))
		pygame.draw.rect(self.surface,(0,0,0), self.rect, 1)
		self.rect = pygame.Rect((self.x-self.sizex+1-5,self.y+self.sizey+5),(self.sizex*2+10-2,5-2))
		self.surface.fill((0,255,0),self.rect)
		if (self.sizex*2+10-2)*(1-self.curHP/self.maxHP) > 0:
			temp = 1- float(self.curHP)/float(self.maxHP)
			self.rect = pygame.Rect((self.x-self.sizex+1-5,self.y+self.sizey+1+4),((self.sizex*2+10-2)*temp,5-2))
			self.surface.fill((255,0,0),self.rect)
			
		if self.usesSteam == True:
			self.rect = pygame.Rect((self.x-self.sizex-5,self.y+self.sizex+4+5),(self.sizey*2+10,5))
			pygame.draw.rect(self.surface,(0,0,0), self.rect, 1)
			self.rect = pygame.Rect((self.x-self.sizex+1-5,self.y+self.sizey+1+4+5),(self.sizey*2+10-2,5-2))
			self.surface.fill((0,0,255),self.rect)
			if (self.sizex*2+10-2)*(1-self.currentSteam/self.maxSteam) > 0:
				temp = 1- float(self.currentSteam)/float(self.maxSteam)
				self.rect = pygame.Rect((self.x-self.sizex+1-5,self.y+self.sizey+1+4+5),((self.sizex*2+10-2)*temp,5-2))
				self.surface.fill((255,0,0),self.rect)
			
	def update(self):
		if self.currentSteam == 0 and self.usesSteam == True:
			#no steam
			myMove = move(self.x,self.y,self.quadrant,self)
			myMove.setNew(self.x,self.y,self.quadrant)
			return myMove
			self.currentSteam -= self.steamUse
		self.olddir = self.direction
		self.move = self.myUpdate()
		if self.move == -1:
			return -1
		if self.move.hasMoved() == False and self.olddir == self.direction:			
			#we didn't move
			return self.move
		else:
			self.currentSteam -= self.steamUse
			if self.currentSteam < 0:
				self.currentSteam = 0
			return self.move
	
	
	def myUpdate(self):		
	
			self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
			#store previous
			self.prevx = self.x
			self.prevy = self.y
			
			#am i dead?
			if self.curHP <= 0:
				return -1
			
			#setup move object
			myMove = move(self.x,self.y,self.quadrant,self)
			if self.goalxattack != -1:
				self.goalx = self.goalxattack
				self.goaly = self.goalyattack
			
			#am i at my goal
			if self.x < self.goalx +.5 and self.x > self.goalx-.5 and self.y < self.goaly+.5 and self.y > self.goaly-.5:
				self.x = self.goalx
				self.y = self.goaly
				self.goalxattack = -1
				self.goalyattack = -1
				myMove.setNew(self.x,self.y,self.quadrant)
				if self.agro == True:
					for u in units:
						if u.team != self.team: 
							self.distanceToTarget = math.sqrt(math.fabs((u.x-self.x))*math.fabs((u.x-self.x)) + math.fabs((u.y-self.y))*math.fabs((u.y-self.y)))
							if self.distanceToTarget <= self.range:
								self.attacking = u
								self.goalx = u.x
								self.goaly = u.y
					for b in buildings:
						if b.team != self.team: 
							self.distanceToTarget = math.sqrt(math.fabs((b.x-self.x))*math.fabs((b.x-self.x)) + math.fabs((b.y-self.y))*math.fabs((b.y-self.y)))
							if self.distanceToTarget <= self.range:
								self.attacking = b
								self.goalx = b.x
								self.goaly = b.y
					
				return myMove

			if self.goalxattack != -1:
						
				if self.agro == True:
					for u in units:
						if u.team != self.team: 
							self.distanceToTarget = math.sqrt(math.fabs((u.x-self.x))*math.fabs((u.x-self.x)) + math.fabs((u.y-self.y))*math.fabs((u.y-self.y)))
							if self.distanceToTarget <= self.range:
								self.attacking = u
								self.goalx = u.x
								self.goaly = u.y
					for b in buildings:
						if b.team != self.team: 
							self.distanceToTarget = math.sqrt(math.fabs((b.x-self.x))*math.fabs((b.x-self.x)) + math.fabs((b.y-self.y))*math.fabs((b.y-self.y)))
							if self.distanceToTarget <= self.range:
								self.attacking = b
								self.goalx = b.x
								self.goaly = b.y
				#we keep on going
				
		
			#be carefull of divide by zero
			if self.y > self.goaly - .25 and self.y < self.goaly + .25:
				self.angleToGoal = 0
			else:
				self.angleToGoal = math.atan(math.fabs(self.goalx-self.x)/math.fabs(self.goaly-self.y))*(180/math.pi)
			if self.goaly - self.y < 0:
				if self.goalx-self.x < 0:
					self.angleToGoal = 360 - self.angleToGoal
				else:
					self.angleToGoal = self.angleToGoal
			else:
				if self.goalx-self.x < 0:
					self.angleToGoal = 180+self.angleToGoal
				else:
					self.angleToGoal = 180 - self.angleToGoal
			
			if self.angleToGoal == self.direction:
				pass
			elif math.fabs(self.angleToGoal - self.direction) < self.turnrate:
				self.direction = self.angleToGoal
				#we have to turn lets break
				myMove.setNew(self.x,self.y,self.quadrant)
				return myMove
			else:
				if self.angleToGoal > self.direction:
					if 360 - self.angleToGoal + self.direction < 180:
						self.direction = self.direction - self.turnrate						
					else:
						self.direction = self.direction + self.turnrate
				else:
					if 360 - self.direction + self.angleToGoal < 180:
						self.direction = self.direction + self.turnrate
					else:
						self.direction = self.direction - self.turnrate
				#we have to turn lets leave
				
				#keepwithin 0 and 360
				if self.direction < 0:
					self.direction = self.direction + 360
				elif self.direction > 360:
					self.direction = self.direction - 360
				myMove.setNew(self.x,self.y,self.quadrant)
				return myMove
	
			#we are facing the right direction
			self.distanceToGoal = math.sqrt(math.fabs((self.goalx-self.x))*math.fabs((self.goalx-self.x)) + math.fabs((self.goaly-self.y))*math.fabs((self.goaly-self.y)))
			if self.attacking == 0:
				
				if self.distanceToGoal <= self.moverate:
					self.x = self.goalx
					self.y = self.goaly
				else:
						
					self.x = self.x+(self.moverate*(self.goalx-self.x))/self.distanceToGoal
					self.y = self.y+(self.moverate*(self.goaly-self.y))/self.distanceToGoal
								
				self.calcQuadrant()
				myMove.setNew(self.x,self.y,self.quadrant)
				
				return myMove
			else:
				if self.attacking in units == False:
					self.attacking = 0
					self.goalx = self.x
					self.goaly = self.y
					myMove.setNew(self.x,self.y,self.quadrant)
					return myMove
				else:
					self.goalx = self.attacking.x
					self.goaly = self.attacking.y
					if self.distanceToGoal <= self.range:
						if self.attacking in units or self.attacking in buildings:
							self.fire()
						
					else:
						self.x = self.x+(self.moverate*(self.goalx-self.x))/self.distanceToGoal
						self.y = self.y+(self.moverate*(self.goaly-self.y))/self.distanceToGoal
					
						self.calcQuadrant()
					myMove.setNew(self.x,self.y,self.quadrant)
					return myMove

	def draw(self):
		if self.showHP == True:
			self.drawHP()
		self.surface = pygame.display.get_surface()
		
		if self.team == 0:
			self.color = (255,0,0)
		if self.team == 1:
			self.color = (0,0,255)
		
		
		self.surface.fill(self.color,pygame.Rect((self.x-self.sizex, self.y-self.sizey),(self.sizex*2, self.sizey*2)))
		if self.selected == True:
			pygame.draw.rect(self.surface,(0,255,0), pygame.Rect(self.x-self.sizex-2, self.y-self.sizey-2,self.sizex*2+2, self.sizey*2+2), 2)
		
		self.endposx = 0
		self.endposy = 0
		if self.direction < 90:			
			self.endposx = self.x+math.sin(self.direction*(math.pi/180))*self.sizex*2
			self.endposy = self.y-math.cos(self.direction*(math.pi/180))*self.sizex*2
		elif self.direction < 180:			
			self.endposx = self.x+math.sin((180-self.direction)*(math.pi/180))*self.sizex*2
			self.endposy = self.y+math.cos((180-self.direction)*(math.pi/180))*self.sizex*2
			
		elif self.direction < 270:
			self.endposx = self.x-math.cos((270-self.direction)*(math.pi/180))*self.sizex*2
			self.endposy = self.y+math.sin((270-self.direction)*(math.pi/180))*self.sizex*2
		else:
			self.endposx = self.x-math.sin((360-self.direction)*(math.pi/180))*self.sizex*2
			self.endposy = self.y-math.cos((360-self.direction)*(math.pi/180))*self.sizex*2
			
		
		pygame.draw.line(self.surface, (100,100,100), (self.x,self.y),(self.endposx,self.endposy), self.sizex/2)
	
	def getPos(self):
		return (self.x,self.y)
	def getQuadrant(self):
		return self.quadrant

	def select(self,amSelected):
		self.selected = amSelected
		
	def setPos(self,x,y):
		self.x = x
		self.y = y
		self.calcQuadrant()
		

	def calcQuadrant(self):
		self.quadrant = []
		#set the quadrant
		if self.y-self.sizey < (GAMESIZEY/3):
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [1]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [2]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [3]
				
		if self.y+self.sizey > GAMESIZEY/3 and self.y-self.sizey < (2*GAMESIZEY)/3:
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [4]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [5]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [6]
				
		if self.y+self.sizey > (2*GAMESIZEY)/3:
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [7]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [8]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [9]

class Tank(Unit):
	def __init__(self,posX,posY,directionOne,directionTwo,curHP,team):
		
		self.directionTwo = directionTwo
		Unit.__init__(self,posX,posY,2,3,directionOne,15,15,100,100,team,150,75,5,True,100,100,.1,15)
		self.turnrateTwo = 6

	def draw(self):
		self.surface = pygame.display.get_surface()
		self.tankbottomimage = tankBottomImages[int((self.direction - 185.625)/11.25)]
		self.tanktopimage = tankTopImages[int((self.directionTwo - 185.625)/11.25)]
		self.surface.blit(self.tankbottomimage,(self.x-self.sizex-25,self.y -self.sizey-20))
		self.surface.blit(self.tanktopimage,(self.x-self.sizex-25,self.y -self.sizey-20))
		
		if self.selected == True:	

			self.temp = pygame.Rect((self.x+13-10-28,self.y+6-10-22),(52,52))
			pygame.draw.rect(self.surface,(0,255,0), self.temp,2)
			self.drawHP()
			
		if self.showHP == True:
			self.drawHP()
		

		
	def myUpdate(self):		
				
		
		self.rect = pygame.Rect(self.x-self.sizex,self.y-self.sizey,self.sizex*2,self.sizey*2)
		#store previous
		self.prevx = self.x
		self.prevy = self.y
				
		#am i dead?
		if self.curHP <= 0:
			return -1
				
		if self.attacking in units or self.attacking in buildings:
			self.goalx = self.attacking.x
			self.goaly = self.attacking.y
		else:
			if self.attacking != 0:			
				self.attacking = 0
				self.goalx = self.x
				self.goaly = self.y
			
		if self.goalxattack != -1:
			self.goalx = self.goalxattack
			self.goaly = self.goalyattack			
			for u in units:
				if u.team != self.team: 
					self.distanceToTarget = math.sqrt(math.fabs((u.x-self.x))*math.fabs((u.x-self.x)) + math.fabs((u.y-self.y))*math.fabs((u.y-self.y)))
					if self.distanceToTarget <= self.range:
						self.attacking = u
						self.goalx = u.x
						self.goaly = u.y
			for b in buildings:
				if b.team != self.team: 
					self.distanceToTarget = math.sqrt(math.fabs((b.x-self.x))*math.fabs((b.x-self.x)) + math.fabs((b.y-self.y))*math.fabs((b.y-self.y)))
					if self.distanceToTarget <= self.range:
						self.attacking = b
						self.goalx = b.x
						self.goaly = b.y
		#setup move object
		myMove = move(self.x,self.y,self.quadrant,self)
		self.distanceToGoal = math.sqrt(math.fabs((self.goalx-self.x))*math.fabs((self.goalx-self.x)) + math.fabs((self.goaly-self.y))*math.fabs((self.goaly-self.y)))
		#am i attacking or not?
		if self.attacking == 0 or self.distanceToGoal > self.range:
			#am i at my goal?
			if self.x == self.goalx and self.y == self.goaly:
				myMove.setNew(self.x,self.y,self.quadrant)
				self.goalxattack = -1
				self.goalyattack = -1
				
				for u in units:
					if u.team != self.team: 
						self.distanceToTarget = math.sqrt(math.fabs((u.x-self.x))*math.fabs((u.x-self.x)) + math.fabs((u.y-self.y))*math.fabs((u.y-self.y)))
						if self.distanceToTarget <= self.range:
							self.attacking = u
							self.goalx = u.x
							self.goaly = u.y
				for b in buildings:
					if b.team != self.team: 
						self.distanceToTarget = math.sqrt(math.fabs((b.x-self.x))*math.fabs((b.x-self.x)) + math.fabs((b.y-self.y))*math.fabs((b.y-self.y)))
						if self.distanceToTarget <= self.range:
							self.attacking = b
							self.goalx = b.x
							self.goaly = b.y
					
				
				return myMove
	
			#be carefull of divide by zero
			if self.y > self.goaly - .25 and self.y < self.goaly + .25:
				self.angleToGoal = 0
			else:
				self.angleToGoal = math.atan(math.fabs(self.goalx-self.x)/math.fabs(self.goaly-self.y))*(180/math.pi)
			if self.goaly - self.y < 0:
				if self.goalx-self.x < 0:
					self.angleToGoal = 360 - self.angleToGoal
				else:
					self.angleToGoal = self.angleToGoal
			else:
				if self.goalx-self.x < 0:
					self.angleToGoal = 180+self.angleToGoal
				else:
					self.angleToGoal = 180 - self.angleToGoal
			
			if self.angleToGoal == self.direction:
				pass
			elif math.fabs(self.angleToGoal - self.direction) < self.turnrate:
				self.direction = self.angleToGoal
				self.directionTwo = self.direction
				#we have to turn lets break
				myMove.setNew(self.x,self.y,self.quadrant)
				return myMove
			else:
				if self.angleToGoal > self.direction:
					if 360 - self.angleToGoal + self.direction < 180:
						self.direction = self.direction - self.turnrate						
					else:
						self.direction = self.direction + self.turnrate
				else:
					if 360 - self.direction + self.angleToGoal < 180:
						self.direction = self.direction + self.turnrate
					else:
						self.direction = self.direction - self.turnrate
				#we have to turn lets leave
				
				#keepwithin 0 and 360
				if self.direction < 0:
					self.direction = self.direction + 360
				elif self.direction > 360:
					self.direction = self.direction - 360
				myMove.setNew(self.x,self.y,self.quadrant)
				self.directionTwo = self.direction
				return myMove
	
			#we are facing the right direction
			
				
			if self.distanceToGoal <= self.moverate:
				self.x = self.goalx
				self.y = self.goaly
					
			else:
				
				self.x = self.x+(self.moverate*(self.goalx-self.x))/self.distanceToGoal
				self.y = self.y+(self.moverate*(self.goaly-self.y))/self.distanceToGoal
					
			self.calcQuadrant()
			myMove.setNew(self.x,self.y,self.quadrant)
				
			return myMove

		else:			
			#we are in range lets find the angle
			
			#be carefull of divide by zero
			if self.y > self.goaly - .25 and self.y < self.goaly + .25:
				self.angleToGoal = 0
			else:
				self.angleToGoal = math.atan(math.fabs(self.goalx-self.x)/math.fabs(self.goaly-self.y))*(180/math.pi)
			if self.goaly - self.y < 0:
				if self.goalx-self.x < 0:
					self.angleToGoal = 360 - self.angleToGoal
				else:
					self.angleToGoal = self.angleToGoal
			else:
				if self.goalx-self.x < 0:
					self.angleToGoal = 180+self.angleToGoal
				else:
					self.angleToGoal = 180 - self.angleToGoal
			
			if math.fabs(self.directionTwo - self.angleToGoal) < 1:
				self.fire()
				
			elif math.fabs(self.directionTwo - self.angleToGoal) <  self.turnrateTwo:
				
				self.directionTwo = self.angleToGoal
				
			else:
				if self.angleToGoal > self.directionTwo:
					if 360 - self.angleToGoal + self.directionTwo < 180:
						self.directionTwo = self.directionTwo - self.turnrateTwo					
					else:
						self.directionTwo = self.directionTwo + self.turnrateTwo
				else:
					if 360 - self.directionTwo + self.angleToGoal < 180:
						self.directionTwo = self.directionTwo + self.turnrateTwo
					else:
						self.directionTwo = self.directionTwo - self.turnrateTwo
				#we have to turn lets leave
				
				#keepwithin 0 and 360
				if self.directionTwo < 0:
					self.directionTwo = self.directionTwo + 360
				elif self.directionTwo > 360:
					self.directionTwo = self.directionTwo - 360
				
			myMove.setNew(self.x,self.y,self.quadrant)
			return myMove

class Worker(Unit):
	def __init__(self,posX,posY,direction,team):
		Unit.__init__(self,posX,posY,4,8,direction,11,19,70,70,team,-1,-1,1,False,0,0,0,0)
		self.currentAnimation = 0
		self.currentFrame = (self.getcardinal(self.direction)+4)%8
		self.frameDelay = 10
		self.delay = 0
		self.linedUp = False
		self.actionInterface = ActionInterface([buildCommandCenter(1,self),buildFarm(2,self),buildAirstrip(3,self),buildFactory(4,self),buildTurret(5,self),getSteam(7,self)])
		self.building = 0
		self.atBuildSite = False
		Unit.agro = False		
		self.resourceType = 0 #1 trees, 2 coal, 3 gold, 4 steam
		self.resourceCarrying = 0
		self.resourceMax = 10
		
		self.resourceGoal = 0
		self.lastresourcegoal = 0
		self.dropOffGoal = 0
		self.goalGetSteam = 0
		self.dropOffSteamGoal = 0
		self.soldier = True		
		self.findNew = False

	def takeDamage(self,d,projOwner):
		self.curHP -= d
		
		#I don't attack cuase i'm Weak!!
		if self.goalx == self.x and self.goaly == self.y and self.attacking == 0:
			#RUNNING
			self.goalx = self.x + random.randrange(20,75,1)*random.randrange(-1,2,2)
			self.goaly = self.y + random.randrange(20,75,1)*random.randrange(-1,2,2)
		
	def setBuildGoal(self,x,y,building):
		self.clearGoals()
		self.goalx = x
		self.goaly = y
		self.building = building

	def clearGoals(self):
		self.resourceGoal = 0
		self.lastresourcegoal = 0
		self.dropOffGoal = 0
		self.goalGetSteam = 0
		self.dropOffSteamGoal = 0	
	
	def setGoal(self,goalX,goalY):	
		self.goalx = goalX
		self.goaly = goalY
		self.clickquad = calcQuad(goalX,goalY)
		self.clickquad = self.clickquad[0]
		self.resourceGoal = 0
		self.clearGoals()
		for b in buildings:
			if b.team == self.team:
				if self.clickquad in b.quadrant:
					if b.rect.collidepoint((goalX,goalY)):
						if ( self.resourceCarrying > 0):
							
							#building can give me steam lets get it									
							self.goalx = b.x
							self.goaly = b.y						
							self.dropOffGoal = b
					
						
		for r in resources:					
			if self.clickquad in r.quadrant:				
				if r.rect.collidepoint((goalX,goalY)):
					self.clearGoals()
					self.resourceGoal = r	
										
		for u in units:			
			if u.team == self.team and u.usesSteam == True :
				if u.currentSteam != u.maxSteam:			
					if self.clickquad in u.quadrant:
						if u.rect.collidepoint((goalX,goalY)):							
							self.clearGoals()
							self.dropOffSteamGoal = u
						
				
	def mine(self):
		if self.team == 1:
			self.searchArea = pygame.Rect(1024-200,668-200,200,200)
		if self.team == 0:
			self.searchArea = pygame.Rect(0,0,200,200)
		self.temp = random.randrange(1,8,1)
		if self.temp == 4 or self.temp == 5:
			self.temp = 3
		if self.temp == 6:
			self.temp = 1
		if self.temp == 7:
			self.temp = 2
		self.clearGoals()
		for r in resources:
			if r.rect.colliderect(self.searchArea) == True and r.mineType == self.temp:
				if r.canmine() == True:
					self.resourceGoal = r
					self.goalx = r.x
					self.goaly = r.y
					self.findNew = False
	def getcardinal(self,direction):
		return int((direction +22.5)/45) % 8
	def getSmallCardinal(self,direction):
		return int((direction + 45) / 90) % 4
	def action(self,act):
		
		if act == 1:
			#build comand center
			if getPlayer(self.team).hasResources(300,300) == True:
				cursor.setMode(2,CommandCenter(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1],self.team,300))
				getPlayer(self.team).takeResources(300,300)			
		elif act == 2:
			#we need to get steam
			for b in buildings:
				if b.team == self.team:
					if b.type == 1:
						#building can give me steam lets get it
						self.clearGoals()
						self.goalx = b.x
						self.goaly = b.y
						self.goalGetSteam = b									
			
		elif act == 3:
			if getPlayer(self.team).hasResources(100,200) == True:				
				cursor.setMode(2,Airstrip(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1],self.team,150))
				getPlayer(self.team).takeResources(100,200)		
		elif act == 4:
			if getPlayer(self.team).hasResources(0,100) == True:				
				cursor.setMode(2,Farm(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1],self.team,100))
				getPlayer(self.team).takeResources(0,100)
		elif act == 5:
			if getPlayer(self.team).hasResources(100,100) == True:				
				cursor.setMode(2,Factory(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1],self.team,150))
				getPlayer(self.team).takeResources(100,100)			
		elif act == 6:
			if getPlayer(self.team).hasResources(100,100) == True:				
				cursor.setMode(2,Turret(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1],self.team,150))
				getPlayer(self.team).takeResources(100,100)
		elif act == 7:
			pass
	def AIaction(self,act,x,y): 
		if act == 1:
			#build comand center
			if getPlayer(self.team).hasResources(300,300) == True:				
				getPlayer(self.team).takeResources(300,300)	
				self.setBuildGoal(x,y,CommandCenter(x,y,self.team,300))
				if self.team == 0:
					self.building.x = self.building.x - self.building.sizex
				elif self.team == 1:
					self.building.x = self.building.x + self.building.sizex
				return 1
		elif act == 2:
			#we need to get steam
			for b in buildings:
				if b.team == self.team:
					if b.type == 1:
						#building can give me steam lets get it
						self.clearGoals()
						self.goalx = b.x
						self.goaly = b.y
						self.goalGetSteam = b									
			
		elif act == 3:
			if getPlayer(self.team).hasResources(100,200) == True:
				getPlayer(self.team).takeResources(100,200)		
				self.setBuildGoal(x,y,Airstrip(x,y,self.team,150))
				if self.team == 0:
					self.building.x = self.building.x - self.building.sizex
				elif self.team == 1:
					self.building.x = self.building.x + self.building.sizex
				return 1
		elif act == 4:
			if getPlayer(self.team).hasResources(0,100) == True:			
				getPlayer(self.team).takeResources(0,100)
				self.setBuildGoal(x,y,Farm(x,y,self.team,100))
				if self.team == 0:
					self.building.x = self.building.x - self.building.sizex
				elif self.team == 1:
					self.building.x = self.building.x + self.building.sizex
				return 1
		elif act == 5:
			if getPlayer(self.team).hasResources(100,100) == True:			
				getPlayer(self.team).takeResources(100,100)	
				self.setBuildGoal(x,y,Factory(x,y,self.team,150))	
				if self.team == 0:
					self.building.x = self.building.x  - self.building.sizex
				elif self.team == 1:
					self.building.x = self.building.x + self.building.sizex
				return 1	
		elif act == 6:
			if getPlayer(self.team).hasResources(100,100) == True:			
				getPlayer(self.team).takeResources(100,100)
				self.setBuildGoal(x,y,Turret(x,y,self.team,150))
				if self.team == 0:
					self.building.x = self.building.x - self.building.sizex
				elif self.team == 1:
					self.building.x = self.building.x + self.building.sizex
				return 1
		elif act == 7:
			pass
		return -1
	def draw(self):
		self.surface = pygame.display.get_surface()
		if self.team == 0:	
			pygame.draw.rect(self.surface,(255,0,0),pygame.Rect(self.x - self.sizex - 2+5, self.y-2+5, self.sizex*2-8, self.sizey-5),0)	
		elif self.team == 1:
			pygame.draw.rect(self.surface,(0,0,255),pygame.Rect(self.x - self.sizex - 2+5, self.y -2+5, self.sizex*2-8, self.sizey-5),0)	
		try :
			
			if self.resourceType == 1:
				self.frame = workerWood[self.currentAnimation][self.currentFrame]
			elif self.resourceType == 0:
				self.frame = workerEmpty[self.currentAnimation][self.currentFrame]
			elif self.resourceType == 2:
				self.frame = workerCoal[self.currentAnimation][self.currentFrame]
			elif self.resourceType == 3:
				self.frame = workerGold[self.currentAnimation][self.currentFrame]
			elif self.resourceType == 4:
				self.frame = workerSteam[self.currentAnimation][self.currentFrame]
		except IndexError:
			print "ERROR"
			print self.currentAnimation
			print self.currentFrame			
					
		self.surface.blit(self.frame,(self.x-26,self.y -25))
		
		if self.building != 0:
			#we need to draw the building
			self.drawToSurface = pygame.Surface((1024,668))
			self.building.drawToSurface(self.drawToSurface)
			#set white to transparent
			
			#set the alpha
			self.drawToSurface.set_alpha(50+205*(1-float(self.building.countBuildTime)/float(self.building.buildTime)))
			self.drawToSurface.set_colorkey((0,0,0))
			self.surface.blit(self.drawToSurface,(0,0))
		
		
		if self.selected == True:
			pygame.draw.rect(self.surface,(0,255,0), pygame.Rect(self.x-self.sizex-2, self.y-self.sizey-2,self.sizex*2+2, self.sizey*2+2), 2)
			self.drawHP()
		if self.showHP == True:
			self.drawHP()

	def update(self):
		self.m = Unit.update(self)	
		
		if self.y > self.goaly - .25 and self.y < self.goaly + .25:
			self.angleToGoal = 0
		else:
			self.angleToGoal = math.atan(math.fabs(self.goalx-self.x)/math.fabs(self.goaly-self.y))*(180/math.pi)
		
		if self.goaly - self.y < 0:
			if self.goalx-self.x < 0:
				self.angleToGoal = 360 - self.angleToGoal
			else:
				self.angleToGoal = self.angleToGoal
		else:
			if self.goalx-self.x < 0:
				self.angleToGoal = 180+self.angleToGoal
			else:
				self.angleToGoal = 180 - self.angleToGoal
				
		self.distanceToGoal = math.sqrt(math.fabs((self.goalx-self.x))*math.fabs((self.goalx-self.x)) + math.fabs((self.goaly-self.y))*math.fabs((self.goaly-self.y)))
		
		if self.building != 0:
			#we need to get some data
			
			if self.distanceToGoal < float(self.building.sizex+self.building.sizey)*1.2 and self.angleToGoal > self.direction -.5 and self.angleToGoal < self.direction + .25:
				#we are close undo the last move and lets build!!
				
				Unit.undo(self) 
				if self.building.countBuildTime > 0:
					self.building.countBuildTime -= 1
				else:
					#were done building
					if self.team == 0:
						teamOneBuildings.append(self.building)
					elif self.team == 1:
						teamOneBuildings.append(self.building)
					buildings.append(self.building)
					self.building.calcQuadrant()
					
					self.building = 0
					self.goalx = self.x
					self.goaly = self.y
					
				self.atBuildSite = True
				if self.currentAnimation < 1 and self.currentAnimation > 4:
					self.currentAnimation = self.getSmallCardinal(self.direction)+1
					self.currentFrame = 0
				else:
					if self.delay > 0:
						self.delay-=1
					else:
						
						self.currentFrame+=1
						self.delay = self.frameDelay
				
				self.currentFrame %= 4	
			else:
				#draw walking
				if self.direction != self.angleToGoal:
					self.linedUp = False
				else:
					if self.linedUp == False:
						self.currentAnimation = self.getcardinal(self.direction) + 1
						
						self.currentFrame = 0
						self.linedUp = True
					else:	
						
						if self.delay > 0:
							self.delay-=1
						else:
							
							self.currentFrame+=1
							self.delay = self.frameDelay
				
			self.currentFrame %= 4	
		elif self.resourceGoal != 0:
			#always walking
			if self.direction > self.angleToGoal-.5 and self.direction < self.angleToGoal+.5:
				self.currentAnimation = self.getcardinal(self.direction) + 1
				if self.delay > 0:
					self.delay-=1
				else:
					
					self.currentFrame+=1
					self.delay = self.frameDelay
					
				self.currentFrame %= 4	
			else:
				
				self.currentAnimation = 0
				self.currentFrame = (self.getcardinal(self.direction)+4)%8	
			
			
			if self.distanceToGoal < self.resourceGoal.sizex*4 and self.angleToGoal > self.direction -.5 and self.angleToGoal < self.direction + .25:
				#were close lets mine
				if getPlayer(self.team).human == False:
					self.undo()
				self.tempData = self.resourceGoal.mine()				
				if self.tempData[0] != -1:
					self.resourceType = self.tempData[1]
					self.resourceCarrying += self.tempData[0]
					if self.resourceCarrying > self.resourceMax:
						self.resourceCarrying = self.resourceMax
						self.lastresourcegoal = self.resourceGoal
						self.resourceGoal = 0
						
						for b in buildings:
							if b.team == self.team and b.type == True: #drop off the cargo
								self.goalx = b.x							
								self.goaly = b.y							
								self.resourceGoal = 0
								self.dropOffGoal = b
					if self.findNew == True:
						self.lastresourcegoal = self.resourceGoal
						self.resourceGoal = 0
						
						for b in buildings:
							if b.team == self.team and b.type == True: #drop off the cargo
								self.goalx = b.x							
								self.goaly = b.y							
								self.resourceGoal = 0
								self.dropOffGoal = b
				else:
					self.findNew = True
					
								
		elif self.dropOffGoal != 0:
			#always walking			
			
			if self.direction > self.angleToGoal-.5 and self.direction < self.angleToGoal+.5:
				self.currentAnimation = self.getcardinal(self.direction) + 1
				if self.delay > 0:
					self.delay-=1
				else:
					
					self.currentFrame+=1
					self.delay = self.frameDelay
					
				self.currentFrame %= 4	
			else:
				self.currentAnimation = 0
				self.currentFrame = (self.getcardinal(self.direction)+4)%8			
			
			if self.distanceToGoal < self.dropOffGoal.sizex+self.dropOffGoal.sizey and self.angleToGoal > self.direction -.5 and self.angleToGoal < self.direction + .25:
				
				self.dropOffGoal.dropResources(int(self.resourceCarrying),self.resourceType)
				self.resourceCarrying = 0
				self.resourceType = 0	
				self.dropOffGoal = 0
				if self.lastresourcegoal != 0:
					if self.lastresourcegoal.resources > 0:
						self.resourceGoal = self.lastresourcegoal				
						self.goalx = self.lastresourcegoal.x
						self.goaly = self.lastresourcegoal.y
					else:
						self.searchArea = pygame.Rect(self.lastresourcegoal.x-50,self.lastresourcegoal.y-50,100,100)
						for r in resources:
							if r.rect.colliderect(self.searchArea):
								self.resourceGoal = r
								self.goalx = r.x
								self.goaly = r.y
				if self.findNew == True:
					if self.team == 1:
						self.searchArea = pygame.Rect(1024-200,668-200,200,200)
					if self.team == 0:
						self.searchArea = pygame.Rect(0,0,200,200)
					for r in resources:
						if r.rect.colliderect(self.searchArea) == True and r.mineType == self.tempData[1]:
							self.temp = False
							for u in units:
								if u.team == self.team and u.actionInterface.actions != []:
									if u.resourceGoal == r:
										self.temp = True
							if self.temp == True:
								pass
							else:
								self.resourceGoal = r
								self.goalx = r.x
								self.goaly = r.y
								self.findNew = False
						
				
		elif self.goalGetSteam != 0:			
			#always walking
			if self.direction > self.angleToGoal-.5 and self.direction < self.angleToGoal+.5:
				self.currentAnimation = self.getcardinal(self.direction) + 1
				if self.delay > 0:
					self.delay-=1
				else:
					
					self.currentFrame+=1
					self.delay = self.frameDelay
					
				self.currentFrame %= 4	
			else:
				self.currentAnimation = 0
				self.currentFrame = (self.getcardinal(self.direction)+4)%8			
			
			if self.distanceToGoal < self.goalGetSteam.sizex*4 and self.angleToGoal > self.direction -.5 and self.angleToGoal < self.direction + .25:
				#we are there
				self.resourceCarrying = getPlayer(self.team).takeResources(self.resourceMax,0)[0]
				self.resourceType = 4
				self.goalx = self.x
				self.goaly = self.y				
				
		elif self.dropOffSteamGoal != 0:
			self.goalx = self.dropOffSteamGoal.x
			self.goaly = self.dropOffSteamGoal.y
			#always walking
			if self.direction > self.angleToGoal-.5 and self.direction < self.angleToGoal+.5:
				self.currentAnimation = self.getcardinal(self.direction) + 1
				if self.delay > 0:
					self.delay-=1
				else:
					
					self.currentFrame+=1
					self.delay = self.frameDelay
					
				self.currentFrame %= 4	
			else:
				self.currentAnimation = 0
				self.currentFrame = (self.getcardinal(self.direction)+4)%8			
			
			if self.distanceToGoal < self.dropOffSteamGoal.sizex*4 and self.angleToGoal > self.direction -.5 and self.angleToGoal < self.direction + .25:
				self.dropOffSteamGoal.currentSteam += self.resourceCarrying
				if self.dropOffSteamGoal.currentSteam > self.dropOffSteamGoal.maxSteam:
					self.resourceCarrying = self.dropOffSteamGoal.currentSteam - self.dropOffSteamGoal.maxSteam
					self.dropOffSteamGoal.currentSteam = self.dropOffSteamGoal.maxSteam
				else:
					self.resourceCarrying = 0
					self.resourceType = 0
				self.dropOffSteamGoal = 0
				self.goalx = self.x
				self.goaly = self.y
				
		elif self.x == self.goalx and self.y == self.goaly:
			#were just sitting here
			self.currentAnimation = 0
			self.currentFrame = (self.getcardinal(self.direction)+4)%8			
			self.delay = self.frameDelay
		else: 
			if self.direction > self.angleToGoal-.5 and self.direction < self.angleToGoal+.5:
				self.linedUp = False
			else:
				if self.linedUp == False:
					self.currentAnimation = self.getcardinal(self.direction) + 1
					
					self.currentFrame = 0
					self.linedUp = True
				else:	
					
					if self.delay > 0:
						self.delay-=1
					else:
						
						self.currentFrame+=1
						self.delay = self.frameDelay
				
			self.currentFrame %= 4	
		return self.m
			
		
class Soldier(Unit):
	def __init__(self,posX,posY,direction,curHP,team):
		Unit.__init__(self,posX,posY,2,6,direction,9,9,curHP,50,team,75,40,2,False,0,0,0,5)
		self.soldier = True
	def draw(self):
		self.surface = pygame.display.get_surface()	
		
		self.surface.blit(soldierPic[self.team*8 + self.getcardinal(self.direction) ],(self.x-self.sizex-5,self.y-self.sizey-3))
		
		if self.selected == True:	

			self.temp = pygame.Rect((self.x-3-9,self.y-3-9),(24,24))
			pygame.draw.rect(self.surface,(0,255,0), self.temp,2)
			self.drawHP()
		if self.showHP == True:
			self.drawHP()
	def getcardinal(self,direction):
		return int((direction +22.5)/45) % 8
class Artillery(Unit):
	def __init__(self,posX,posY,direction,curHP,team,currentSteam):
		Unit.__init__(self,posX,posY,2,3,direction,13,13,curHP,50,team,400,125,4,True,150,currentSteam,.01,45)
			
	def draw(self):
		self.surface = pygame.display.get_surface()		
	
		self.surface.blit(artilleryPics[self.getcardinal(self.direction)],(self.x-30,self.y-28))
		
		if self.selected == True:	

			self.temp = pygame.Rect((self.x-15,self.y-15),(28,28))
			pygame.draw.rect(self.surface,(0,255,0), self.temp,2)
			self.drawHP()
		if self.showHP == True:
			self.drawHP()
			
	def fire(self):
		if self.firecounter != 0:
			self.firecounter -= 1
		else:				
			p = ArtilleryProjectile(self.x,self.y,self.goalx+random.randrange(-20,21,1),self.goaly+random.randrange(-20,21,1),45,self)		
			projs.append(p)
			self.firecounter = self.firerate
	def getcardinal(self,direction):
		return int((direction +22.5)/45) % 8
class Plane(Unit):
	def __init__(self,posX,posY,direction,curHP,team,currentSteam,homeField):
		Unit.__init__(self,posX,posY,6,10,direction,13,13,curHP,50,team,50,30,4,True,150,currentSteam,.1,13)
		self.homeField = homeField
		
	def draw(self):
		self.surface = pygame.display.get_surface()		
		
		self.surface.blit(planePics[self.getcardinal(self.direction)],(self.x-self.sizex-5,self.y-self.sizey-5))
		
		if self.selected == True:	

			self.temp = pygame.Rect((self.x-21,self.y-21),(38,38))
			pygame.draw.rect(self.surface,(0,255,0), self.temp,2)
			self.drawHP()
		if self.showHP == True:
			self.drawHP()	
	def getcardinal(self,direction):
		return int((direction +22.5)/45) % 8

	def update(self):
		if self.currentSteam < 20 and self.currentSteam > 0:
			
			if self.homeField != 0:
				self.oldgoalx = self.goalx
				self.oldgoaly = self.goaly
				self.oldattacking = self.attacking
				
				self.goalx = self.homeField.x
				self.goaly = self.homeField.y
				self.move = self.myUpdate()
				
				# need some data
				if self.y > self.goaly - .25 and self.y < self.goaly + .25:
					self.angleToGoal = 0
				else:
					self.angleToGoal = math.atan(math.fabs(self.goalx-self.x)/math.fabs(self.goaly-self.y))*(180/math.pi)
				
				if self.goaly - self.y < 0:
					if self.goalx-self.x < 0:
						self.angleToGoal = 360 - self.angleToGoal
					else:
						self.angleToGoal = self.angleToGoal
				else:
					if self.goalx-self.x < 0:
						self.angleToGoal = 180+self.angleToGoal
					else:
						self.angleToGoal = 180 - self.angleToGoal
						
				self.distanceToGoal = math.sqrt(math.fabs((self.goalx-self.x))*math.fabs((self.goalx-self.x)) + math.fabs((self.goaly-self.y))*math.fabs((self.goaly-self.y)))
				#got the data
				
				if self.distanceToGoal < self.homeField.sizex*4 and self.angleToGoal > self.direction -.5 and self.angleToGoal < self.direction + .25:
					self.currentSteam += getPlayer(self.team).takeResources(int(self.maxSteam - self.currentSteam),0)[0]
					self.goalx = self.oldgoalx
					self.goaly = self.oldgoaly
					self.attacking = self.oldattacking
		if self.currentSteam == 0 and self.usesSteam == True:
			#no steam
			myMove = move(self.x,self.y,self.quadrant,self)
			myMove.setNew(self.x,self.y,self.quadrant)
			return myMove
			self.currentSteam -= self.steamUse
		self.olddir = self.direction
		self.move = self.myUpdate()
		if self.move == -1:
			return -1
		if self.move.hasMoved() == False and self.olddir == self.direction:			
			#we didn't move
			return self.move
		else:
			self.currentSteam -= self.steamUse
			if self.currentSteam < 0:
				self.currentSteam = 0
			return self.move
class GUI:
	"""Controls all of the GUI and menus of the game"""
	def __init__(self):
		self.surface = pygame.display.get_surface()
		
		self.guirect = pygame.Rect((0,668),(1024,100))
		self.menu = pygame.Rect((0,668),(100,25))
		self.exit = pygame.Rect((100,668),(100,25))
		self.logo = pygame.Rect((0,692),(200,74))
		self.selected = pygame.Rect((200,668),(400,100))
		self.steam = pygame.Rect((700,668),(120,25))
		self.money = pygame.Rect((820,668),(120,25))
		self.food = pygame.Rect((940,668),(83,25))
		self.actionOne = pygame.Rect((700,694),(323,74))
		self.actionTwo = pygame.Rect((600,668),(100,100))
		
		self.rects = [self.guirect,self.menu,self.exit,self.logo,self.selected,self.steam,self.money,self.food,self.actionOne, self.actionTwo]
	def draw(self):
		self.surface = pygame.display.get_surface()
		
		#self.surface.fill((255,255,255),pygame.Rect((0,668),(1023,100)))
		
		self.outlinepointlist = ((0,668),(1022,668),(1022,766),(0,766))
		pygame.draw.lines(self.surface, (0,0,0), True, self.outlinepointlist, 2)
		
		pygame.draw.line(self.surface, (0,0,0), (0,693),(200,693),2)
		pygame.draw.line(self.surface, (0,0,0), (100,668),(100,693),2)
		pygame.draw.line(self.surface, (0,0,0), (200,668),(200,767),2)
		pygame.draw.line(self.surface, (0,0,0), (623,693),(623,767),2)
		pygame.draw.line(self.surface, (0,0,0), (623,693),(723,693),2)
		pygame.draw.line(self.surface, (0,0,0), (723,668),(723,693),2)
		pygame.draw.line(self.surface, (0,0,0), (823,668),(823,693),2)
		pygame.draw.line(self.surface, (0,0,0), (923,668),(923,693),2)
		pygame.draw.line(self.surface, (0,0,0), (723,693),(1023,693),2)
		pygame.draw.line(self.surface, (0,0,0), (623,730),(1023,730),2)
		pygame.draw.line(self.surface, (0,0,0), (723,693),(723,767),2)
		pygame.draw.line(self.surface, (0,0,0), (823,693),(823,767),2)
		pygame.draw.line(self.surface, (0,0,0), (923,693),(923,767),2)
		
		
		
		self.surface.blit(guiPics[0],(730,668))
		self.surface.blit(guiPics[1],(830,665))
		self.surface.blit(guiPics[2],(922,666))
		
		#draw the text
		if pygame.font:
			self.font = pygame.font.Font(None, 36)
			self.menutext = self.font.render("Menu", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (18,665)
			self.surface.blit(self.menutext, self.menutextpos)
			
			self.exittext = self.font.render("Exit", 1, (10, 10, 10))
			self.exittextpos = self.exittext.get_rect()
			self.exittextpos.topleft = (128,665)
			self.surface.blit(self.exittext, self.exittextpos)
			
			self.actionstext = self.font.render("Actions", 1, (10, 10, 10))
			self.actionstextpos = self.actionstext.get_rect()
			self.actionstextpos.topleft = (627,700)
			self.surface.blit(self.actionstext, self.actionstextpos)
			
			
			self.resources = compuPlayer.getStates()
			
			self.font = pygame.font.Font(None, 25)
			
			self.actionstext = self.font.render(str(self.resources[0]), 1, (10, 10, 10))
			self.actionstextpos = self.actionstext.get_rect()
			self.actionstextpos.topleft = (760,670)
			self.surface.blit(self.actionstext, self.actionstextpos)
			
			self.actionstext = self.font.render(str(self.resources[1]), 1, (10, 10, 10))
			self.actionstextpos = self.actionstext.get_rect()
			self.actionstextpos.topleft = (860,670)
			self.surface.blit(self.actionstext, self.actionstextpos)
			
			self.actionstext = self.font.render(str(self.resources[2]) + "/" + str(self.resources[3]), 1, (10, 10, 10))
			self.actionstextpos = self.actionstext.get_rect()
			self.actionstextpos.topleft = (955,670)
			self.surface.blit(self.actionstext, self.actionstextpos)
		
	def click(self,pos):
		"""Handles a click at position pos"""
		#first see if the object is in the corret area
		if self.guirect.collidepoint(pos) == True:
			if self.menu.collidepoint(pos) == True:
				pass
			elif self.exit.collidepoint(pos) == True:
				
				#return the code to quit
				return -1
			elif self.logo.collidepoint(pos) == True:
				
				pass
			elif self.selected.collidepoint(pos) == True:
				
				pass
			elif self.money.collidepoint(pos) == True:
				
				pass
			elif self.food.collidepoint(pos) == True:
				
				pass
			elif self.steam.collidepoint(pos) == True:
				
				pass
			elif self.actionOne.collidepoint(pos) == True or self.actionTwo.collidepoint(pos) == True:
				if cursor.actionInterface != []:
					cursor.actionInterface.click(pos)
				#for b in cursor.selectedBuild:
				#	b.action(0)
				
				
class Cursor:

	def __init__(self):
		self.selected = []
		self.selectedBuild = []
		self.lButtonDown = False
		self.selectStart = 0
		self.surface = pygame.display.get_surface()
		self.selectBox = pygame.Rect(0,0,0,0)
		self.actionInterface = []
		self.mode = 1
	
	def setMode(self,newMode,newbuild):
		self.mode = newMode
		self.building = newbuild

	def update(self):
		#called every loop to update everything
		self.surface = pygame.display.get_surface()
		pygame.mouse.set_visible(True)
		
		if self.mode == 1:			
			self.overGui = False
	
			pygame.event.get()
			if self.actionInterface != []:
				self.actionInterface.draw()
	
			if pygame.mouse.get_pressed()[0] == True:
				if gui.guirect.collidepoint((pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])) == True:
					pygame.draw.rect(self.surface,(100,100,100), self.selectBox, 2)
					return
	
				#lbutton down
				if self.lButtonDown == False:
					#The lButton was just pressed so clear the selected and start the select box
					self.lButtonDown = True
					self.selectBox = pygame.Rect(pygame.mouse.get_pos(),(0,0))
					self.selectStart = pygame.mouse.get_pos()
					self.selected = [0]
			
				else:
					#lbutton was already down so just change the second part of the select box
					self.newPos = pygame.mouse.get_pos()
					self.topLeft = [0,0]
					self.distance = [0,0]
			
					#find top left
					if self.newPos[0] < self.selectStart[0]:
						
						self.topLeft[0] = self.newPos[0]
						self.distance[0] = self.selectStart[0] - self.newPos[0]
	
					else:
						self.topLeft[0] = self.selectStart[0]
						self.distance[0] = self.newPos[0] - self.selectStart[0]
					if self.newPos[1] < self.selectStart[1]:
						self.topLeft[1] = self.newPos[1]
						self.distance[1] = self.selectStart[1] - self.newPos[1]
					else:
						self.topLeft[1] = self.selectStart[1] 
						self.distance[1] = self.newPos[1] - self.selectStart[1]
	
					self.selectBox = pygame.Rect(self.topLeft,self.distance)
					
					
					pygame.draw.rect(self.surface,(100,100,100), self.selectBox, 2)
			
			else:
	
			
				#lubbton up
				if self.lButtonDown == True:
					#lbutton was just down so select
					self.select()
	
				self.lButtonDown = False
				self.selectBox = pygame.Rect((0,0),(0,0))
			
			if pygame.mouse.get_pressed()[2] == True:
				for s in self.selected:				
					s.setGoal(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])
				for b in self.selectedBuild:
					b.setGoal(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])
		else:
			#building mode
			pygame.mouse.set_visible(False)
			
			#set white to transparent
			
			#set the alpha
			self.drawToSurface = pygame.Surface((1024,668))
			
			for u in units:
				self.drawToSurface.fill((255,255,0),pygame.Rect((u.x-u.sizex*2,u.y-u.sizey*2),(u.sizex*4,u.sizey*4)))				
			for b in buildings:
				self.drawToSurface.fill((255,255,0),pygame.Rect((b.x-b.sizex*2,b.y-b.sizey*2),(b.sizex*4,b.sizey*4)))
			for r in resources:
				self.drawToSurface.fill((255,255,0),pygame.Rect((r.x-r.sizex*2,r.y-r.sizey*2),(r.sizex*4,r.sizey*4)))

			self.building.x = pygame.mouse.get_pos()[0]
			self.building.y = pygame.mouse.get_pos()[1]			
			self.building.drawToSurface(self.drawToSurface)
			
			self.drawToSurface.set_alpha(100)
			self.drawToSurface.set_colorkey((0,0,0))
			self.surface.blit(self.drawToSurface,(0,0))
			
			
			
			pygame.event.get()	
			if pygame.mouse.get_pressed()[0] == True and pygame.mouse.get_pos()[1] < 669:
				
				self.doNothing = False
				for u in units:
					if self.building.rect.colliderect(pygame.Rect((u.x-u.sizex,u.y-u.sizey),(u.sizex*2,u.sizey*2))) == True:
						self.doNothing = True
				for b in buildings:
					if self.building.rect.colliderect(b.rect) == True:
						self.doNothing = True
				if self.doNothing == False:
					self.selected[0].setBuildGoal(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1],self.building)
					self.mode = 1
					self.building = 0
			
	
			
	

	def select(self):
		#called when the mouse is released
		#selects all of the units in the select boxif newPos[0] < selectStart[0]:
		self.selected = []
		self.oldwidth = self.selectBox.width
		self.oldheight = self.selectBox.height
		self.selectBox = pygame.Rect((self.selectBox.left - 7, self.selectBox.top - 7),(self.selectBox.width + 14, self.selectBox.height + 14))
			
		self.selectedBuild = []
		for b in buildings:
			if self.selectBox.colliderect(b.rect) == True and b.team == humanPlayer.team:
				self.selectedBuild = self.selectedBuild + [b]
				b.select(True)
			else:
				b.select(False)
				
		if self.selectedBuild != []:
			for b in self.selectedBuild:
				b.select(False)
			self.selectedBuild = [self.selectedBuild[0]]
			self.selectedBuild[0].select(True)
			self.actionInterface = self.selectedBuild[0].actionInterface
		
		if self.selectedBuild == []:
			#units only selected if building isn't
			self.actionInterface = []
			for unit in units:
				if self.selectBox.collidepoint(unit.getPos()) == True and unit.team == humanPlayer.team:
					self.selected = self.selected + [unit]
					self.actionInterface = unit.actionInterface
					unit.select(True)
				else:
					unit.select(False)
			if self.oldwidth < 3 and self.oldheight < 3 and self.selected != []:
				for b in self.selected:
					b.select(False)
				self.selected = [self.selected[0]]
				self.selected[0].select(True)
				self.actionInterface = self.selected[0].actionInterface
		else:
			#deselecet call units
			for unit in units:
				unit.select(False)
				
	def getSelected(self):
		return self.selected

class Resource:
	def __init__(self,x,y,sizex,sizey,resources,mineType,mineAmount):
		self.image = resourcePics[0]
		self.x = x
		self.y = y
		self.sizex = sizex
		self.sizey = sizey
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		self.resources = resources
		self.calcQuadrant()
		self.mineAmount = mineAmount
		self.mineType = mineType
		self.beingmined = False
	def draw(self):
		self.surface = pygame.display.get_surface()	
		self.surface.fill((0,0,0),self.rect)
		self.surface.blit(self.image,(self.x-self.sizex-6,self.y -self.sizey-13))		
		
	def update(self):
		self.beingmined = False
		if self.resources <= 0:
			return -1
	
	def action(self,act):
		pass
	
	def calcQuadrant(self):
		self.quadrant = []
		#set the quadrant
		if self.y-self.sizey < (GAMESIZEY/3):
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [1]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [2]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [3]
				
		if self.y+self.sizey > GAMESIZEY/3 and self.y-self.sizey < (2*GAMESIZEY)/3:
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [4]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [5]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [6]
				
		if self.y+self.sizey > (2*GAMESIZEY)/3:
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [7]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [8]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [9]
	def mine(self):
		#were being mined
		if self.beingmined == False:
			self.resources -= self.mineAmount
			self.beingmined = True
			return (self.mineAmount,self.mineType)	
		else:
			return (-1,self.mineType)
	def canmine(self):
		if self.beingmined == True:
			return False
		else:
			return True
class Tree(Resource):
	
	def __init__(self,x,y,resources):
		Resource.__init__(self,x,y,10,10,resources,1,.2)
		self.image = resourcePics[0]
	def draw(self):
		self.surface = pygame.display.get_surface()	
		#self.surface.fill((0,0,0),self.rect)
		self.surface.blit(self.image,(self.x-self.sizex-6,self.y -self.sizey-13))
class Coal(Resource):
	
	def __init__(self,x,y,resources):
		Resource.__init__(self,x,y,15,15,resources,2,.2)
		self.image = resourcePics[1]
	def draw(self):
		self.surface = pygame.display.get_surface()	
		#self.surface.fill((0,0,0),self.rect)
		self.surface.blit(self.image,(self.x-self.sizex-3,self.y -self.sizey-4))
class Gold(Resource):
	
	def __init__(self,x,y,resources):
		Resource.__init__(self,x,y,11,11,resources,3,.2)
		self.image = resourcePics[2]
	def draw(self):
		self.surface = pygame.display.get_surface()	
		#self.surface.fill((0,0,0),self.rect)
		self.surface.blit(self.image,(self.x-self.sizex-2,self.y -self.sizey-5))
class Building:
	
	def __init__(self,x,y,sizex,sizey,team,buildCooldown,buildTime,curHP,maxHP,type):
		self.x = x
		self.y = y
		self.sizex = sizex
		self.sizey = sizey
		self.team = team
		self.rect = pygame.Rect((x-self.sizex,y-self.sizey),(self.sizex*2,self.sizey*2))
		self.surface = pygame.display.get_surface()
		self.selected = False
		self.buildCooldown = buildCooldown
		self.currentCooldown = -1
		self.actionInterface = ActionInterface([Action(1,self)])
		self.updateSurface = True
		self.buildTime = buildTime
		self.countBuildTime = buildTime
		self.curHP = curHP
		self.maxHP = maxHP
		self.showHP = False
		self.calcQuadrant()
		self.type = type
		self.farm = 0
	def dropResources(self,amount,type):
		if type == 1:
			getPlayer(self.team).recieveResources(amount,0)
		elif type == 2:
			getPlayer(self.team).recieveResources(amount*2,0)
		elif type == 3:
			getPlayer(self.team).recieveResources(0,amount)
			
	def drawHP(self):
		self.rect = pygame.Rect((self.x-self.sizex-5,self.y+(self.sizey)-3+5),(self.sizex*2+10,5))
		pygame.draw.rect(self.surface,(0,0,0), self.rect, 1)
		self.rect = pygame.Rect((self.x-self.sizex+1-5,self.y+(self.sizey)+1-3+5),(self.sizex*2+10-2,5-2))
		self.surface.fill((0,255,0),self.rect)
		if (self.sizex*2+10-2)*(1-self.curHP/self.maxHP) > 0:
			temp = 1- float(self.curHP)/float(self.maxHP)
			self.rect = pygame.Rect((self.x-self.sizex+1-5,self.y+(self.sizey)+1-3+5),((self.sizex*2+10-2)*temp,5-2))
			self.surface.fill((255,0,0),self.rect)
		
			
	def calcQuadrant(self):
		self.quadrant = []
		#set the quadrant
		if self.y-self.sizey < (GAMESIZEY/3):
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [1]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [2]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [3]
				
		if self.y+self.sizey > GAMESIZEY/3 and self.y-self.sizey < (2*GAMESIZEY)/3:
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [4]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [5]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [6]
				
		if self.y+self.sizey > (2*GAMESIZEY)/3:
			if self.x-self.sizex < (GAMESIZEX/3):
				self.quadrant = self.quadrant + [7]
			if self.x-self.sizex < (2*GAMESIZEX)/3 and self.x+self.sizex > (GAMESIZEX/3):
				self.quadrant = self.quadrant + [8]
			if self.x+self.sizex > (2*GAMESIZEX)/3:
				self.quadrant = self.quadrant + [9]
				
	def takeDamage(self,d,projOwner):
		self.curHP -= d		
		
	
	def update(self):
		if self.curHP <= 0:
			return -1
		if self.currentCooldown > 0:
			self.currentCooldown -= 1			
		if self.currentCooldown == 0:
			#done building
			
			self.temp = Unit(self.x-self.sizex,self.y+self.sizey+10,1,2,0,5,5,10,10,self.team,1000,50,2)
			self.collide = True
			while self.collide == True:
				self.collide = False
				for u in units:									
					if u.rect.colliderect(self.temp.rect):
						self.collide = True
				for b in buildings:
					if b.rect.colliderect(self.temp.rect):
						self.collide = True
				if self.collide == True:
					self.temp.x = self.temp.x + self.temp.sizex + 10
					if self.temp.x > self.x+self.sizex:
						self.temp.x = self.x-self.sizex
						self.temp.y = self.temp.y + self.temp.sizey + 10
					self.temp.rect = pygame.Rect((self.temp.x-self.temp.sizex,self.temp.y-self.temp.sizey),(self.temp.sizex*2,self.temp.sizey*2))
			self.temp.goalx = self.temp.x
			self.temp.goaly = self.temp.y
			if self.team == 0:
				teamOneUnits.append(self.temp)
			elif self.team == 1:
				teamTwoUnits.append(self.temp)
			units.append(self.temp)
			self.currentCooldown = -1
			
	def draw(self):
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		if self.updateSurface == True:
			self.surface = pygame.display.get_surface()
		
		if self.team == 0:
			self.color = (255,0,0)
		elif self.team == 1:
			self.color = (0,0,255)
		self.surface.fill(self.color,self.rect)
		
		if self.selected == True:
			self.outline = pygame.Rect((self.x-self.sizex-2,self.y-self.sizey-2),(self.sizex*2+3,self.sizey*2+3))
			pygame.draw.rect(self.surface, (0,255,0), self.outline, 2)
			self.drawHP()
		self.updateSurface = True
		
		if self.showHP == True:
			self.drawHP()
	def HPshow(self,toShow):
		self.showHP = toShow
	def drawToSurface(self,surface):
		self.surface = surface
		self.updateSurface = False
		self.draw()
	def getPos(self):
		return (self.x,self.y)
	def select(self,select):
		self.selected = select
	
	def setGoal(self,x,y):
		pass
		
	def action(self,act):
		"""there is an action for us! yay!"""
		if act == 0:
			#lez build
			self.currentCooldown = self.buildCooldown[0]
class Airstrip(Building):
	def __init__(self,x,y,team,curHP):
		Building.__init__(self,x,y,24,24,team,(20),20,curHP,150,False)
		self.actionInterface = ActionInterface([buildPlane(1,self)])
		self.buildCooldown = 20
	def draw(self):
		
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		
		if self.updateSurface == True:
			self.surface = pygame.display.get_surface()
		
		self.surface.blit(airstripPic,(self.x-24,self.y-24))
		if self.selected == True:
			self.outline = pygame.Rect((self.x-self.sizex-2,self.y-self.sizey-2),(self.sizex*2+3,self.sizey*2+3))
			pygame.draw.rect(self.surface, (0,255,0), self.outline, 2)
			self.drawHP()
		self.updateSurface = True
		
		if self.showHP == True:
			self.drawHP()
	def update(self):
		if self.curHP <= 0:
			return -1
		if self.currentCooldown > 0:
			self.currentCooldown -= 1			
		if self.currentCooldown == 0:
			#done building
			
			self.temp = Plane(self.x-self.sizex,self.y+self.sizey+10,0,50,self.team,150,self)
			self.collide = True
			while self.collide == True:				
				self.collide = False
				for u in units:									
					if u.rect.colliderect(self.temp.rect):
						self.collide = True
				for b in buildings:
					if b.rect.colliderect(self.temp.rect):
						self.collide = True
				for r in resources:
					if r.rect.colliderect(self.temp.rect):
						self.collide = True
				if self.collide == True:
					self.temp.x = self.temp.x + self.temp.sizex 
					if self.temp.x > self.x+self.sizex:
						self.temp.x = self.x-self.sizex
						if self.temp.y > self.y:
							self.temp.y = self.temp.y + self.temp.sizey 
						if self.temp.y < self.y:
							self.temp.y = self.temp.y - self.temp.sizey 
						if self.temp.y -self.x > 200 or self.temp.y > 628:
							self.temp.y = self.y -self.sizey-10
					self.temp.rect = pygame.Rect((self.temp.x-self.temp.sizex,self.temp.y-self.temp.sizey),(self.temp.sizex*2,self.temp.sizey*2))
			self.temp.goalx = self.temp.x
			self.temp.goaly = self.temp.y
			if self.team == 0:
				teamOneUnits.append(self.temp)
			elif self.team == 1:
				teamTwoUnits.append(self.temp)
			units.append(self.temp)
			self.currentCooldown = -1
			
	def action(self,act):
		"""there is an action for us! yay!"""
		if act == 1:
			#lez build a plane
			if getPlayer(self.team).hasResources(50,100) == True and getPlayer(self.team).hasFood(4) == True and self.currentCooldown == -1:
				self.currentCooldown = self.buildCooldown
				getPlayer(self.team).takeResources(50,100)				
class CommandCenter(Building):
	def __init__(self,x,y,team,curHP):
		if curHP > 300:
			curHP = 300
		Building.__init__(self,x,y,36,22,team,(20,30),200,curHP,300,True)
		self.actionInterface = ActionInterface([buildWorker(1,self),buildSoldier(2,self)])
		self.unitbuilding = 0
		
	def draw(self):
	
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		
		if self.updateSurface == True:
			self.surface = pygame.display.get_surface()
		
		self.surface.blit(commandcenterPic,(self.x-self.sizex-18,self.y-self.sizey-17))
		if self.selected == True:
			self.outline = pygame.Rect((self.x-self.sizex-2,self.y-self.sizey-2),(self.sizex*2+3,self.sizey*2+3))
			pygame.draw.rect(self.surface, (0,255,0), self.outline, 2)
		self.updateSurface = True
		
		if self.showHP == True:
			self.drawHP()
			
	def action(self,act):
		"""there is an action for us! yay!"""
		if act == 1:
			#lez build a worker
			if getPlayer(self.team).hasResources(0,50) == True and getPlayer(self.team).hasFood(1) == True and self.currentCooldown == -1:
				self.currentCooldown = self.buildCooldown[0]
				getPlayer(self.team).takeResources(0,50)
				self.unitbuilding = 1
		elif act == 2:
			#lez build a soldier
			if getPlayer(self.team).hasResources(0,75) == True and getPlayer(self.team).hasFood(2) == True and self.currentCooldown == -1:
				self.currentCooldown = self.buildCooldown[1]
				getPlayer(self.team).takeResources(0,75)
				self.unitbuilding = 2
	def update(self):
		if self.curHP <= 0:
			return -1
		if self.currentCooldown > 0:
			self.currentCooldown -= 1			
		if self.currentCooldown == 0:
			#done building
			if self.unitbuilding == 1:
				self.temp = Worker(self.x-self.sizex,self.y+self.sizey+10,0,self.team)
			elif self.unitbuilding == 2:
				self.temp = Soldier(self.x-self.sizex,self.y-self.sizey-10,0,50,self.team)
			self.collide = True
			while self.collide == True:
				if self.unitbuilding == 1 and getPlayer(self.team).human == False:
					break
				self.collide = False
				for u in units:									
					if u.rect.colliderect(self.temp.rect):
						self.collide = True
				for b in buildings:
					if b.rect.colliderect(self.temp.rect):
						self.collide = True
				for r in resources:
					if r.rect.colliderect(self.temp.rect):
						self.collide = True
				if self.collide == True:
					self.temp.x = self.temp.x + self.temp.sizex 
					if self.temp.x > self.x+self.sizex:
						self.temp.x = self.x-self.sizex
						if self.temp.y > self.y:
							self.temp.y = self.temp.y + self.temp.sizey 
						if self.temp.y < self.y:
							self.temp.y = self.temp.y - self.temp.sizey 
						if self.temp.y -self.x > 200 or self.temp.y > 608:
							self.temp.y = self.y -self.sizey-10
					self.temp.rect = pygame.Rect((self.temp.x-self.temp.sizex,self.temp.y-self.temp.sizey),(self.temp.sizex*2,self.temp.sizey*2))
			self.temp.goalx = self.temp.x
			self.temp.goaly = self.temp.y
			if self.team == 0:
				teamOneUnits.append(self.temp)
			elif self.team == 1:
				teamTwoUnits.append(self.temp)
			units.append(self.temp)
			self.currentCooldown = -1
class Factory(Building):
	def __init__(self,x,y,team,curHP):
		if curHP > 150:
			curHP = 150
		Building.__init__(self,x,y,38,22,team,(63,42),200,curHP,150,False)
		self.actionInterface = ActionInterface([buildTank(1,self),buildArtillery(2,self)])
		self.unitbuilding = 0
		
	def draw(self):
	
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		
		if self.updateSurface == True:
			self.surface = pygame.display.get_surface()		
		self.surface.blit(factoryPic,(self.x-self.sizex-1,self.y-self.sizey-5))
		if self.selected == True:
			self.outline = pygame.Rect((self.x-self.sizex-2,self.y-self.sizey-2),(self.sizex*2+3,self.sizey*2+3))
			pygame.draw.rect(self.surface, (0,255,0), self.outline, 2)
			self.drawHP()
		self.updateSurface = True
		
		if self.showHP == True:
			self.drawHP()
			
	def action(self,act):
		"""there is an action for us! yay!"""
		if act == 1:
			#lez build a tank
			if getPlayer(self.team).hasResources(100,75) == True and getPlayer(self.team).hasFood(4) == True and self.currentCooldown == -1:
				self.currentCooldown = self.buildCooldown[0]
				getPlayer(self.team).takeResources(100,75)
				self.unitbuilding = 1
		elif act == 2:
			#lez build an artillery piece
			if getPlayer(self.team).hasResources(150,75) == True and getPlayer(self.team).hasFood(3) == True and self.currentCooldown == -1:
				self.currentCooldown = self.buildCooldown[1]
				getPlayer(self.team).takeResources(150,75)
				self.unitbuilding = 2
	def update(self):
		if self.curHP <= 0:
			return -1
		if self.currentCooldown > 0:
			self.currentCooldown -= 1			
		if self.currentCooldown == 0:
			#done building
			if self.unitbuilding == 1:				
				self.temp = Tank(self.x-self.sizex,self.y+self.sizey+10,0,0,100,self.team)
			elif self.unitbuilding == 2:				
				self.temp = Artillery(self.x-self.sizex,self.y+self.sizey+10,0,50,self.team,150)
			self.collide = True
			while self.collide == True:				
				self.collide = False
				for u in units:									
					if u.rect.colliderect(self.temp.rect):
						self.collide = True
				for b in buildings:
					if b.rect.colliderect(self.temp.rect):
						self.collide = True
				for r in resources:
					if r.rect.colliderect(self.temp.rect):
						self.collide = True
				if self.collide == True:
					self.temp.x = self.temp.x + self.temp.sizex 
					if self.temp.x > self.x+self.sizex:
						self.temp.x = self.x-self.sizex
						if self.temp.y > self.y:
							self.temp.y = self.temp.y + self.temp.sizey 
						if self.temp.y < self.y:
							self.temp.y = self.temp.y - self.temp.sizey 
						if self.temp.y -self.x > 200 or self.temp.y > 608:
							self.temp.y = self.y -self.sizey-10
					self.temp.rect = pygame.Rect((self.temp.x-self.temp.sizex,self.temp.y-self.temp.sizey),(self.temp.sizex*2,self.temp.sizey*2))
			self.temp.goalx = self.temp.x
			self.temp.goaly = self.temp.y
			if self.team == 0:
				teamOneUnits.append(self.temp)
			elif self.team == 1:
				teamTwoUnits.append(self.temp)
			units.append(self.temp)
			self.currentCooldown = -1
class Farm(Building):
	def __init__(self,x,y,team,curHP):
		if curHP > 100:
			curHP = 100
		Building.__init__(self,x,y,12,19,team,(0),30,curHP,100,False)
		self.actionInterface = ActionInterface([])
		self.farm = 10
	def draw(self):	
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		
		if self.updateSurface == True:
			self.surface = pygame.display.get_surface()			
		self.surface.blit(farmPic,(self.x-self.sizex-1,self.y-self.sizey))
		if self.selected == True:
			self.outline = pygame.Rect((self.x-self.sizex-2,self.y-self.sizey-2),(self.sizex*2+3,self.sizey*2+3))
			self.drawHP()
			pygame.draw.rect(self.surface, (0,255,0), self.outline, 2)
		self.updateSurface = True
		
		if self.showHP == True:
			self.drawHP()
class Turret(Building):
	def __init__(self,x,y,team,curHP,direction):
		if curHP > 50:
			curHP = 50
		Building.__init__(self,x,y,10,10,team,(0),30,curHP,50,False)
		self.actionInterface = ActionInterface([])		
		self.range = 150
		self.direction = direction
		self.goalx = 0
		self.goaly = 0
		self.firecounter = 3
		self.firerate = 3

	def draw(self):	
		self.rect = pygame.Rect((self.x-self.sizex,self.y-self.sizey),(self.sizex*2,self.sizey*2))
		
		if self.updateSurface == True:
			self.surface = pygame.display.get_surface()		
		if self.team == 0:
			self.surface.blit(turretPicsRed[self.getcardinal(self.direction)],(self.x-self.sizex-11,self.y-self.sizey-20))
		elif self.team == 1:
			self.surface.blit(turretPicsBlue[self.getcardinal(self.direction)],(self.x-self.sizex-11,self.y-self.sizey-20))
		if self.selected == True:
			self.outline = pygame.Rect((self.x-self.sizex-2,self.y-self.sizey-2),(self.sizex*2+3,self.sizey*2+3))
			pygame.draw.rect(self.surface, (0,255,0), self.outline, 2)
			self.drawHP()
		self.updateSurface = True
		
		if self.showHP == True:
			self.drawHP()
			
		
	def getcardinal(self,direction):
		return int((direction +22.5)/45) % 8

	def fire(self):
		if self.firecounter != 0:
			self.firecounter -= 1
		else:			
			p = TurretProjectile(self.x,self.y,self.goalx,self.goaly,5,self)		
			projs.append(p)
			self.firecounter = self.firerate
		
	def update(self):		
		
		if self.curHP <= 0:
			return -1
		if self.currentCooldown > 0:
			self.currentCooldown -= 1			
		for u in units:
			if u.team != self.team and u.soldier == True:
				self.distanceToTarget = math.sqrt(math.fabs((u.x-self.x))*math.fabs((u.x-self.x)) + math.fabs((u.y-self.y))*math.fabs((u.y-self.y)))
				if self.distanceToTarget <= self.range:
					self.goalx = u.x
					self.goaly = u.y
					#lets light em up					
					
					#be carefull of divide by zero
					if self.y > self.goaly - .25 and self.y < self.goaly + .25:
						self.angleToGoal = 0
					else:
						self.angleToGoal = math.atan(math.fabs(self.goalx-self.x)/math.fabs(self.goaly-self.y))*(180/math.pi)
					if self.goaly - self.y < 0:
						if self.goalx-self.x < 0:
							self.angleToGoal = 360 - self.angleToGoal
						else:
							self.angleToGoal = self.angleToGoal
					else:
						if self.goalx-self.x < 0:
							self.angleToGoal = 180+self.angleToGoal
						else:
							self.angleToGoal = 180 - self.angleToGoal
					self.direction = self.angleToGoal
					self.fire()
					
class Action:
	def __init__(self,pos,owner):
		self.pos = pos
		if self.pos == 1:
			self.rect = pygame.Rect((723,693),(100,37))
		elif self.pos == 2:
			self.rect = pygame.Rect((823,693),(100,37))
		elif self.pos == 3:
			self.rect = pygame.Rect((923,693),(100,37))
		elif self.pos == 4:
			self.rect = pygame.Rect((623,730),(100,37))
		elif self.pos == 5:
			self.rect = pygame.Rect((723,730),(100,37))
		elif self.pos == 6:
			self.rect = pygame.Rect((823,730),(100,37))
		elif self.pos == 7:
			self.rect = pygame.Rect((923,730),(100,37))
		self.owner = owner
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.fill((0,0,0),self.rect)
				
	def clicked(self):
		self.owner.action(0)
		
class ActionInterface:
	def __init__(self,actions):
		self.actions = actions
	def draw(self):
		for a in self.actions:
			a.draw()
	def click(self,pos):
		for a in self.actions:
			if a.rect.collidepoint(pos) == True:
				a.clicked()
				
class buildCommandCenter(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(pygame.transform.rotozoom(commandcenterPic, 0, .55),(self.rect.left-6,self.rect.top-3))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+42,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+40,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("300", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+57,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("300", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+57,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)

	def clicked(self):
		self.owner.action(1)
class buildPlane(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(planePics[0],(self.rect.left+2,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+35,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+33,self.rect.top+16))
		self.temp = pygame.transform.rotozoom(guiPics[2], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+77,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("50", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)
			
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("4", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+83,self.rect.top+2)
			self.surface.blit(self.menutext, self.menutextpos)
		pygame.draw.line(self.surface,(0,0,0), (self.rect.left+81,self.rect.top+4), (self.rect.left+81,self.rect.bottom-4),2)
	def clicked(self):
		self.owner.action(1)
class buildWorker(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(workerGold[0][0],(self.rect.left-7,self.rect.top-7))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+35,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+33,self.rect.top+16))
		self.temp = pygame.transform.rotozoom(guiPics[2], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+74,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("0", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("50", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)
			
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("1", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+80,self.rect.top+2)
			self.surface.blit(self.menutext, self.menutextpos)
		pygame.draw.line(self.surface,(0,0,0), (self.rect.left+78,self.rect.top+4), (self.rect.left+78,self.rect.bottom-4),2)
	def clicked(self):
		self.owner.action(1)
class buildTank(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(pygame.transform.rotozoom(tankBottomImages[0],0,.75),(self.rect.left-13,self.rect.top-8))
		self.surface.blit(pygame.transform.rotozoom(tankTopImages[0],0,.75),(self.rect.left-13,self.rect.top-8))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+35,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+33,self.rect.top+16))
		self.temp = pygame.transform.rotozoom(guiPics[2], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+75,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("75", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)
			
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("4", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+81,self.rect.top+2)
			self.surface.blit(self.menutext, self.menutextpos)
		pygame.draw.line(self.surface,(0,0,0), (self.rect.left+80,self.rect.top+4), (self.rect.left+80,self.rect.bottom-4),2)
	def clicked(self):
		self.owner.action(1)
class buildArtillery(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(pygame.transform.rotozoom(artilleryPics[2],0,.75),(self.rect.left+1,self.rect.top-5))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+35,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+33,self.rect.top+16))
		self.temp = pygame.transform.rotozoom(guiPics[2], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+75,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("150", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)
			
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("3", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+81,self.rect.top+2)
			self.surface.blit(self.menutext, self.menutextpos)
		pygame.draw.line(self.surface,(0,0,0), (self.rect.left+80,self.rect.top+4), (self.rect.left+80,self.rect.bottom-4),2)
	def clicked(self):
		self.owner.action(2)
class buildSoldier(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(soldierPic[self.owner.team*8+4],(self.rect.left+4,self.rect.top+4))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+35,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+33,self.rect.top+16))
		self.temp = pygame.transform.rotozoom(guiPics[2], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+74,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("0", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("75", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+50,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)
			
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("2", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+80,self.rect.top+2)
			self.surface.blit(self.menutext, self.menutextpos)
		pygame.draw.line(self.surface,(0,0,0), (self.rect.left+78,self.rect.top+4), (self.rect.left+78,self.rect.bottom-4),2)
	def clicked(self):
		self.owner.action(2)
class buildAirstrip(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(pygame.transform.rotozoom(airstripPic, 0, .75),(self.rect.left+2,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+37,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+35,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+52,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("200", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+52,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)

	def clicked(self):
		self.owner.action(3)
class buildFarm(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(pygame.transform.rotozoom(farmPic, 0, .9),(self.rect.left+2,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+37,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+35,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("0", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+52,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+52,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)

	def clicked(self):
		self.owner.action(4)

class buildFactory(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.blit(pygame.transform.rotozoom(factoryPic, 0, .9),(self.rect.left+2,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+55,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+53,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+70,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+70,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)

	def clicked(self):
		self.owner.action(5)

class buildTurret(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		
		self.surface.blit(pygame.transform.rotozoom(turretPics[4], 0, .9),(self.rect.left+2,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[0], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+55,self.rect.top+2))
		self.temp = pygame.transform.rotozoom(guiPics[1], 0, .7)
		self.surface.blit(self.temp,(self.rect.left+2+53,self.rect.top+16))
		if pygame.font:
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+70,self.rect.top+1)
			self.surface.blit(self.menutext, self.menutextpos)
		
			self.font = pygame.font.Font(None, 24)
			self.menutext = self.font.render("100", 1, (10, 10, 10))
			self.menutextpos = self.menutext.get_rect()
			self.menutextpos.topleft = (self.rect.left+2+70,self.rect.top+16)
			self.surface.blit(self.menutext, self.menutextpos)

	def clicked(self):
		self.owner.action(6)
		
class getSteam(Action):
	def __init__(self,pos,owner):
		Action.__init__(self,pos,owner)
	def draw(self):
		self.surface = pygame.display.get_surface()
		self.surface.fill((0,0,255),self.rect)
		self.surface.blit(pygame.transform.rotozoom(workerSteam[0][0], 0, 1),(self.rect.left+2,self.rect.top-4))
		self.surface.blit(pygame.transform.rotozoom(workerSteam[0][0], 0, 1),(self.rect.left+47,self.rect.top-4))
	def clicked(self):
		self.owner.action(2)
#Game Over

class Player:
	def __init__(self,team,steam,gold,myunits,buildings,human,commandcenter):
		self.team = team
		self.gold = gold
		self.steam = steam
		self.units = myunits
		self.buildings = buildings
		self.food = self.calcFood()[0]
		self.foodCap = 100
		self.foodMax = self.calcFood()[1]
		self.human = human
		self.haveFactory = False
		self.haveAirport = False
		self.commandcenter = commandcenter
		self.buildx = 0
		self.buildy = 0
		if self.team == 0:
			self.buildx = 900
			self.buildy = 50
		elif self.team == 1:
			self.buildx = 1024-600
			self.buildy = 668-50
		self.buildingFarm = False
		self.farmbuilder = 0
		self.buildingFactory = False
		self.factorybuilder = 0
		self.buildingAirstrip = False
		self.airstripbuilder = 0
		self.attacking = False
		self.factory = 0
		self.airstrip = 0
	def removeUnit(self,u):
		self.units.remove(u)
	def calcFood(self):
		self.temp = 0
		self.tempTwo = 0
		for u in units:
			if u.team == self.team:
				self.temp += u.food
		for b in buildings:
			if b.team == self.team:
				self.tempTwo += b.farm
		return (self.temp,self.tempTwo)

	def hasFood(self,i):
		if self.foodMax - self.food >=i:
			return True
		else:
			return False

	def update(self):	
		self.food = self.calcFood()[0]
		self.foodMax = self.calcFood()[1]
		
		if self.human == False:
			#AI FUN!!!
			self.workers = 0
			for u in units:
				if u.actionInterface.actions != [] and u.team == self.team:
					self.workers += 1
					if u.building == 0 and u.resourceGoal == 0 and u.dropOffGoal == 0 and u.goalGetSteam == 0 and u.dropOffSteamGoal == 0:
						#unit is doing nothing
						u.mine()
					
			if self.farmbuilder != 0:
				if self.farmbuilder.building == 0:					
					self.buildingFarm = False
			if self.factorybuilder != 0:
				if self.factorybuilder.building == 0:
					self.buildingFactory = False
					self.factorybuilder = 0
			if self.airstripbuilder != 0:
				if self.airstripbuilder.building == 0:
					self.buildingAirstrip = False
					self.airstripbuilder = 0
					
			if self.foodMax - self.food < 5 and self.buildingFarm == False:				
				for u in units:
					if u.actionInterface.actions != [] and u.team == self.team:
						#we have a worker
						if u.building == 0 and u.goalGetSteam == 0 and u.dropOffSteamGoal == 0 and self.buildingFarm == False:
							#worker isn't building or getting steam
							if u.AIaction(4,self.buildx,self.buildy) == 1:
								if self.team == 0:
									self.buildx -= u.building.sizex*2
								elif self.team == 1:
									self.buildx += u.building.sizex*2
								self.buildingFarm = True
								self.farmbuilder = u
							
			elif self.workers < 15:
				self.commandcenter.action(1)
			elif self.haveFactory == False and self.buildingFarm == False:
				self.haveFactory = True
				for u in units:
					if u.actionInterface.actions != [] and u.team == self.team and self.buildingFactory == False:
						#we have a worker
						if u.building == 0 and u.goalGetSteam == 0 and u.dropOffSteamGoal == 0:
							#worker isn't building or getting steam
							if u.AIaction(5,self.buildx,self.buildy) == 1:
								if self.team == 0:
									self.buildx -= u.building.sizex*2+10
								elif self.team == 1:
									self.buildx += u.building.sizex*2+10
								self.buildingFactory = True
								self.factorybuilder = u
								self.factory = self.factorybuilder.building								
			elif self.haveAirport == False and self.buildingFactory == False and self.buildingFarm == False:
				self.haveAirport = True
				for u in units:
					if u.actionInterface.actions != [] and u.team == self.team and self.buildingAirstrip == False:
						#we have a worker
						if u.building == 0 and u.goalGetSteam == 0 and u.dropOffSteamGoal == 0:
							#worker isn't building or getting steam
							if u.AIaction(3,self.buildx,self.buildy) == 1:
								if self.team == 0:
									self.buildx -= u.building.sizex*2+10
								elif self.team == 1:
									self.buildx += u.building.sizex*2+10
								self.buildingAirstrip = True
								self.airstripbuilder = u
								self.airstrip = self.airstripbuilder.building
			elif self.factory != 0 and self.airstrip != 0 and self.factorybuilder == 0 and self.airstripbuilder == 0:
				
				self.temp = random.randrange(0,4,1)
				if self.temp == 0:
					self.commandcenter.action(2)
				elif self.temp == 1:
					self.airstrip.action(1)
				elif self.temp == 2:
					self.factory.action(1)
				elif self.temp == 3:
					self.factory.action(2)
			if self.food > 40:			
				for u in units:
					if u.team == self.team and u.actionInterface.actions == [] and u.goalxattack == -1:
						#attackmove
						
						if self.team == 1:							
							u.attackMove(random.randrange(0,300),random.randrange(0,200))
						if self.team == 0:							
							u.attackMove(random.randrange(724,1024),random.randrange(400,668))
			else:
				for u in units:
					if u.team == self.team and u.actionInterface.actions == []:
						u.goalx = u.x
						u.goaly = u.y
		self.haveBuilding = False
		for b in buildings:
			if b.team == self.team:
				self.haveBuilding = True
		if self.haveBuilding == False:
			return -1


	def recieveResources(self,steam,gold):		
		self.steam += steam
		self.gold += gold
	def hasResources(self,steam,gold):
		if self.steam >= steam and self.gold >= gold:
			return True
		else:
			return False
	def takeResources(self,steam,gold):
		self.steam -= steam
		self.gold -= gold
		amountSteam = steam
		amountGold = gold
		
		if self.steam < 0:
			self.amountSteam = self.steam + steam
			self.steam = 0
		if self.gold < 0:
			self.amountGold = self.gold + gold
			self.gold = 0
		return (amountSteam,amountGold)
	
	def getStates(self):
		return (self.steam,self.gold,self.food,self.foodMax)

class Map:
	def __init__(self,map):
		#array is 69,45
		self.array = []
		if map == 0:
			i = 0
			m = 0
			while i < 70:
				temp = []
				m = 0
				while m < 45:
					temp.append(random.randrange(0,4))
					m+=1				
				self.array.append(temp)
				i+=1
			i = 1
			m = 1
			l = 0
			while l < 3:
				i = 0
				while i < 21:				
					m = 0
					while m < 15:
						a = -1
						b = -1
						t = [0,0,0,0,0]			
						while a < 2:
							while b < 2:
								t[self.array[i+a][m+b]] +=1
								b+=1
							b = -1
							a+=1
						if t[0] >= 5:
							self.array[i][m] = 0
						if t[1] >= 5:
							self.array[i][m] = 1
						if t[2] >= 5:
							self.array[i][m] = 2
						if t[3] >= 5:
							self.array[i][m] = 3
						if t[4] >= 5:
							self.array[i][m] = 3
						if t[0] >= 6:
							self.array[i][m] = 0
						if t[1] >= 6:
							self.array[i][m] = 1
						if t[2] >= 6:
							self.array[i][m] = 2
						if t[3] >= 6:
							self.array[i][m] = 3
						if t[4] >= 6:
							self.array[i][m] = 3
						m+=1	
					i+=1
				l+=1
			i = 0
			while i < 21:
				self.array[i][13] == self.array[i][12]
				i+=1
			i = 0
			while i < 21:
				if int(float(i)*.619) <= 13:
					self.array[i][int(13-float(i)*.619)] = 5
				if int(float(i)*.619)+1 <= 13:
					self.array[i][int(13-float(i)*.619)+1] = 5
				if int(float(i)*.619)-1 <= 13:
					self.array[i][int(13-float(i)*.619)-1] = 5
				i+=1
		else:
			self.array = map

	def draw(self):		
		
		self.surface = pygame.Surface((1024,768))		
		self.surface.convert()
		self.surface.fill((250, 250, 250))
		i = 0
		m = 0
		while i < 21:
			m = 0		
			while m < 14:	
				self.surface.blit(mapPics[self.array[i][m]],(i*50,m*50))
				if i > 0:
					k = 0
					while k < 5:
						if self.array[i][m] == k and self.array[i-1][m] == k:
							self.surface.blit(mapPicsT[k][1],(i*50-8,m*50))
						k+=1
				if m > 0:
					k = 0
					while k < 5:
						if self.array[i][m] == k and self.array[i][m-1] == k:
							self.surface.blit(mapPicsT[k][0],(i*50,m*50-8))
						k+=1				
				if self.array[i][m] == 5:
					if self.array[i-1][m] != 5:
						self.surface.blit(mapPicsT[5][1],(i*50-8,m*50))
					if self.array[i][m-1] != 5:
						self.surface.blit(mapPicsT[5][0],(i*50,m*50-8))
				if self.array[i][m] != 5:
					if self.array[i-1][m] == 5:
						self.surface.blit(mapPicsT[5][1],(i*50-8,m*50))
					if self.array[i][m-1] == 5:
						self.surface.blit(mapPicsT[5][0],(i*50,m*50-8))
				m+=1			
			i+=1
		self.surface.fill((255,255,255),pygame.Rect((0,668),(1024,100)))
		return self.surface


		
def main():
	
	
	"""this function is called when the program starts.
		it initializes everything it needs, then runs in
		a loop until the function returns."""
	#Initialize Everything
	pygame.init()
	screen = pygame.display.set_mode((1024, 768))
	pygame.display.set_caption('.1 Beta')
	
	
	pygame.mouse.set_visible(1)

	#Create The Backgound
	background = pygame.Surface(screen.get_size())
	background = background.convert()
	background.fill((250, 250, 250))
	

	#Display The Background
	screen.blit(background, (0, 0))
	pygame.display.flip()

	#Prepare Game Objects
	clock = pygame.time.Clock()
	map.draw()	
	
	jkl = False
	screenR = 0
	#Main Loop
	while 1:
		if screenR == 0:	
			pygame.event.pump()
			surfaceT = pygame.display.get_surface()
			screen.blit(images[0],(0,0))
			pygame.event.get()	
			if pygame.mouse.get_pressed()[0] == True:
				screenR +=1
				jkl = True
			pygame.display.flip()
			continue
		if screenR == 1:
			pygame.event.pump()
			surfaceT = pygame.display.get_surface()
			screen.blit(images[1],(0,0))
			pygame.event.get()				
			if pygame.mouse.get_pressed()[0] == True and jkl == False:
				screenR +=1
			jkl = pygame.mouse.get_pressed()[0]
			pygame.display.flip()
			continue
		if screenR == 3:
			pygame.event.pump()
			surfaceT = pygame.display.get_surface()
			screen.blit(images[2],(0,0))
			if pygame.mouse.get_pressed()[0] == True and jkl == False:
				return
			jkl = pygame.mouse.get_pressed()[0]
			pygame.display.flip()
			continue
		else:
			clock.tick(60)
			
			
			#Handle Input Events
			for event in pygame.event.get():
				if event.type == QUIT:
					return
				elif event.type == MOUSEBUTTONDOWN:
					if event.button == 1:
						action = gui.click(event.pos)
						if action == -1:
							return
			#allsprites.update()
			pygame.event.pump()
			m = pygame.key.get_mods()
			if m & KMOD_LALT or m & KMOD_RALT:
				for u in units:
					u.HPshow(True)
				for b in buildings:
					b.HPshow(True)
			else:
				for u in units:
					u.HPshow(False)
				for b in buildings:
					b.HPshow(False)

			if getPlayer(0).update() == -1:
				screenR +=1
			if getPlayer(1).update() == -1:
				screenR +=1
			#Draw Everything
			#first clear screen
			screen.blit(background, (0, 0))
			#now really lets draw
			screen.blit(map.surface,(0,0))
			cursor.update()
			moveList = []
			
			for u in units:
				temp = u.update()			
				
				if temp == -1:
					getPlayer(u.team).removeUnit(u)
					units.remove(u)
				else:
					try:
						temp.quadrant						
					except AttributeError:
						print "Error"
						print temp						
					moveList = moveList + [temp]
					
			
			for m in moveList:
				for n in moveList:
					if m != n:
						if m.unit.actionInterface.actions == [] or n.unit.actionInterface.actions == []:
							collide = False
							if m.collide(n) == True:
								#we have a collision						
								m.unit.undo()
								collide = True
							if n.collide(m) == True:							
								if collide == True and m.unit.team == n.unit.team:
									n.unit.undo()
								n.unit.changePos(n.oldx-n.newx,n.oldy-n.newy)
						elif m.unit.team != n.unit.team:
							collide = False
							if m.collide(n) == True:
								#we have a collision						
								m.unit.undo()
								collide = True
							if n.collide(m) == True:							
								if collide == True and m.unit.team == n.unit.team:
									n.unit.undo()
								n.unit.changePos(n.oldx-n.newx,n.oldy-n.newy)	
				for b in buildings:
					if m.collideBuilding(b) == True:
						if b.team == m.unit.team and getPlayer(b.team).human == False:
							#were gonna cheat a little (alot actually)
							pass
						else:
							m.unit.undo()
				for r in resources:
					if m.collideBuilding(r) == True:
						if getPlayer(m.unit.team).human == False and m.unit.actionInterface.actions != []:
							#more cheating
							pass
						else:
							m.unit.undo()
			for b in buildings:
				if b.update() == -1:
					buildings.remove(b)
				b.draw()
				
			for u in units:				
				u.draw()
			for r in resources:
				if r.update() == -1:
					resources.remove(r)
				else:
					r.draw()
					
			
			for p in projs:				
				if p.update() == 1:
					p.blow(units)
					projs.remove(p)
					
				p.draw()
				
			gui.draw()
			
			
			
			pygame.display.flip()


cursor = Cursor()
gui = GUI()
unit = Soldier(560,300,230,50,1)
unitTwo = Worker(500,500,0,1)
unitThree = Tank(100,100,0,90,50,1)
unitFour = Artillery(200,100,0,20,1,150)
unitFive = Plane(300,300,180,1,1,2,0)
teamOneUnits = [Soldier(560,300,230,50,0),Soldier(580,300,230,50,0),Soldier(540,300,230,50,0),Soldier(520,300,230,50,0)]#unit,Unit(200,100,1,2,0,5,5,10,10,0,100,50,2,False,0,0,0),Unit(300,100,1,2,0,5,5,10,10,0,100,50,2,False,0,0,0)
teamTwoUnits = [unitTwo]#Unit(600,500,1,2,0,5,5,10,10,1,100,30),Unit(700,500,1,2,0,5,5,10,10,1,100,30)
units = teamOneUnits + teamTwoUnits



projs = []

resources = [Tree(600,600,10),Tree(615,600,10),Tree(615,615,10),Tree(600,615,10),Coal(700,600,100),Gold(800,600,10)]
resources = []
t = random.randrange(3,8)
c = random.randrange(2,5)
g = random.randrange(2,5)
while t >= 1:
	temp = random.randrange(10,30)
	resources.append(Tree(t*temp+100,15+random.randrange(0,15),150))
	resources.append(Tree(924-t*temp,663-random.randrange(0,15),150))
	t-=1
while c >= 1:
	temp = random.randrange(20,30)
	resources.append(Coal(15+random.randrange(0,15),t*temp+g*temp+50,150))
	resources.append(Coal(1009-random.randrange(0,15),628-t*temp - g*temp,150))
	c-=1
while g >= 1:
	tempOne = random.randrange(10,60)
	tempTwo = random.randrange(10,60)
	if tempOne > 30:
		tempTwo = random.randrange(10,20)
	elif tempTwo > 30:
		tempOne = random.randrange(10,20)
	resources.append(Gold(tempOne,tempTwo,400))
	resources.append(Gold(1024-tempOne,668-tempTwo,400))
	g-=1
map = Map(0)

teamOneBuildings = []
teamTwoBuildings = []
buildings = []
c1 = CommandCenter(150,150,0,300)
c2 = CommandCenter(874,518,1,300)
teamOneBuildings = [c1,Farm(150+random.randrange(50,100),150+random.randrange(50,100),0,100)]
teamTwoBuildings = [c2,Farm(874-random.randrange(50,100),518-random.randrange(50,100),1,100)]

i = 0
while i < 10:
	xt = 924*float(i)/10+30
	teamOneBuildings.append(Turret(xt,568-float(xt)*.63,0,150,135))
	i+=1
i = 0
while i < 10:
	xt = 924*float(i)/10+130
	teamTwoBuildings.append(Turret(xt,668-(float(xt)-100)*.61,1,150,300))
	i+=1
buildings = teamOneBuildings + teamTwoBuildings		
teamOneUnits = [Worker(50,50,0,0),Soldier(200,100,230,50,0),Soldier(100,200,230,50,0)]
teamTwoUnits = [Worker(972,618,0,1),Soldier(814,468,230,50,1),Soldier(834,468,230,50,1)]
units = teamOneUnits + teamTwoUnits
humanPlayer = Player(0,500,500,teamOneUnits,teamOneBuildings,True,c1)		
compuPlayer = Player(1,500,500,teamTwoUnits,teamTwoBuildings,False,c2)

#this calls the 'main' function when this script is executed
if __name__ == '__main__': main()
